package org.springframework.data.domain;

import lombok.EqualsAndHashCode;

@EqualsAndHashCode
public class PageRequest implements Pageable {
    private final long offset;
    private final long limit;
    private final Sort sort;

    public PageRequest(long offset, long limit) {
        this(offset, limit, null);
    }

    public PageRequest(long offset, long limit, Sort sort) {
        this.offset = offset;
        this.limit = limit;
        this.sort = sort;
    }

    @Override
    public long getOffset() {
        return offset;
    }

    @Override
    public long getLimit() {
        return limit;
    }

    @Override
    public Sort getSort() {
        return sort;
    }
}
