package org.springframework.data.domain;

import lombok.EqualsAndHashCode;

@EqualsAndHashCode
public class Sort {
    private final Direction desc;
    private final String property;

    public Sort(Direction desc, String property) {

        this.desc = desc;
        this.property = property;
    }

    public boolean isAscending() {
        return desc == Direction.ASC;
    }

    public String getProperty() {
        return property;
    }

    public enum Direction { ASC, DESC }
}
