package se.su.dsv.scipro.data.dataobjects;

import lombok.Data;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;

@Data
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class Member implements Serializable {
    private final User user;
    private final Type type;

    public enum Type  {
        AUTHOR {
            @Override
            public String toString() {
                return "Author";
            }
        },
        SUPERVISOR {
            @Override
            public String toString() {
                return "Supervisor";
            }
        },
        REVIEWER {
            @Override
            public String toString() {
                return "Reviewer";
            }
        },
        CO_SUPERVISOR {
            @Override
            public String toString() {
                return "Co-Supervisor";
            }
        },
        OPPONENT {
            @Override
            public String toString() {
                return "Opponent";
            }
        },
        ACTIVE_PARTICIPANT {
            @Override
            public String toString() {
                return "Active Participant";
            }
        },
        CREATOR {
            @Override
            public String toString() {
                return "Creator";
            }
        },
        CO_AUTHOR {
            @Override
            public String toString() {
                return "Co-Author";
            }
        },
        PEER_REQUESTER {
            @Override
            public String toString() {
                return "Requester";
            }
        },
        PEER_REVIEWER {
            @Override
            public String toString() {
                return "Peer reviewer";
            }
        },
        MILESTONE_INDIVIDUAL {
            @Override
            public String toString() {
                return "Individual milestone";
            }
        }, EXAMINER {
        	@Override
        	public String toString() {
        		return "Examiner";
        	}
        }
    }

    public Member(User user, Type type) {
        this.user = user;
        this.type = type;
    }

    public User getUser() {
        return user;
    }
}
