package se.su.dsv.scipro.finalseminar;

import com.mysema.query.BooleanBuilder;
import com.mysema.query.types.expr.BooleanExpression;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.AbstractServiceImpl;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.List;

public class FinalSeminarOppositionServiceImpl extends AbstractServiceImpl<FinalSeminarOpposition, Long> implements FinalSeminarOppositionService {
    @Inject
    public FinalSeminarOppositionServiceImpl(Provider<EntityManager> em) {
        super(em, FinalSeminarOpposition.class, QFinalSeminarOpposition.finalSeminarOpposition);
    }

    @Override
    public List<FinalSeminarOpposition> findAll(FilterParams params) {
        return findAll(fromParams(params));
    }

    private BooleanBuilder fromParams(FilterParams params) {
        BooleanBuilder bb = new BooleanBuilder();
        if (params.getStudent() != null) {
            bb.and(hasStudent(params.getStudent()));
        }
        if (params.getProject() != null) {
            bb.and(hasProject(params.getProject()));
        }
        if (params.getFinalSeminar() != null) {
            bb.and(hasFinalSeminar(params.getFinalSeminar()));
        }
        return bb;
    }

    private BooleanExpression hasFinalSeminar(FinalSeminar finalSeminar) {
        return QFinalSeminarOpposition.finalSeminarOpposition.finalSeminar.eq(finalSeminar);
    }

    private BooleanExpression hasProject(Project project) {
        return QFinalSeminarOpposition.finalSeminarOpposition.project.eq(project);
    }

    private BooleanExpression hasStudent(User student) {
        return QFinalSeminarOpposition.finalSeminarOpposition.user.eq(student);
    }
}
