package se.su.dsv.scipro.finalseminar;

import com.google.inject.persist.Transactional;
import se.su.dsv.scipro.system.AbstractServiceImpl;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

public class FinalSeminarSettingsServiceImpl extends AbstractServiceImpl<FinalSeminarSettings,Long> implements FinalSeminarSettingsService {

	private static final long INSTANCE_ID = 1L;

	@Inject
	public FinalSeminarSettingsServiceImpl(Provider<EntityManager> em) {
        super(em, FinalSeminarSettings.class, QFinalSeminarSettings.finalSeminarSettings);
	}

	@Override
	@Transactional
	public FinalSeminarSettings getInstance() {
		FinalSeminarSettings settings = findOne(INSTANCE_ID);
		if(settings==null) {
			settings = new FinalSeminarSettings(INSTANCE_ID);
			save(settings);
		}
		return settings;
	}
}
