package se.su.dsv.scipro.forum;

import se.su.dsv.scipro.forum.dataobjects.GroupThread;
import se.su.dsv.scipro.forum.dataobjects.QGroupThread;
import se.su.dsv.scipro.group.Group;
import se.su.dsv.scipro.system.GenericRepo;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.List;

class GroupThreadRepositoryImpl extends GenericRepo<GroupThread, Long> implements GroupThreadRepository {

    @Inject
    GroupThreadRepositoryImpl(Provider<EntityManager> em) {
        super(em, GroupThread.class, QGroupThread.groupThread);
    }

    @Override
    public List<GroupThread> findByGroup(Group group) {
        return findAll(QGroupThread.groupThread.group.eq(group));
    }

}
