package se.su.dsv.scipro.forum.dataobjects;

import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "forum_post_read")
public class ForumPostReadState implements Serializable {

    @EmbeddedId
    private ForumPostReadStateId id;

    @Basic
    @Column(name = "`read`", nullable = false)
    private boolean read = false;

    public ForumPostReadState() {
    }

    public ForumPostReadState(final User user, final ForumPost post) {
        id = new ForumPostReadStateId(user, post);
    }

    public ForumPostReadStateId getId() {
        return id;
    }

    public void setId(final ForumPostReadStateId id) {
        this.id = id;
    }

    public boolean isRead() {
        return read;
    }

    public void setRead(final boolean read) {
        this.read = read;
    }
}

