package se.su.dsv.scipro.forum.notifications;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import se.su.dsv.scipro.forum.dataobjects.ForumPost;
import se.su.dsv.scipro.notifications.dataobject.NotificationEvent;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "forum_notification")
@EqualsAndHashCode
@ToString
class ForumNotification {
    @EmbeddedId
    private Id id = new Id();

    @ManyToOne(optional = false)
    @MapsId("forumPostId")
    private ForumPost forumPost;

    @ManyToOne(optional = false)
    @MapsId("notificationEventId")
    private NotificationEvent notificationEvent;

    protected ForumNotification() { } // JPA

    ForumNotification(final ForumPost forumPost, final NotificationEvent notificationEvent) {
        this.forumPost = forumPost;
        this.notificationEvent = notificationEvent;
    }

    public ForumPost getForumPost() {
        return forumPost;
    }

    public NotificationEvent getNotificationEvent() {
        return notificationEvent;
    }

    @Data
    @Embeddable
    static class Id implements Serializable {
        private Long forumPostId;
        private Long notificationEventId;
    }
}
