package se.su.dsv.scipro.forummail;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.mail.MailEvent;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;

@Entity
@Table(name = "forum_mail")
@Inheritance(strategy = InheritanceType.JOINED)
@Data
@EqualsAndHashCode(callSuper = true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class ForumMail extends DomainObject {
    @Id
    @GeneratedValue
    private Long id;

    @ManyToOne(optional = false)
    private MailEvent mailEvent;

    @ManyToOne(optional = false)
    private User user;

    protected ForumMail(){} // JPA

    protected ForumMail(final MailEvent mailEvent, final User user) {
        this.mailEvent = mailEvent;
        this.user = user;
    }
}
