package se.su.dsv.scipro.forummail;

import com.google.inject.AbstractModule;
import com.google.inject.multibindings.Multibinder;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsServiceImpl;
import se.su.dsv.scipro.mail.MailEventService;
import se.su.dsv.scipro.springdata.serviceimpls.UserProfileServiceImpl;
import se.su.dsv.scipro.springdata.services.UserProfileService;
import se.su.dsv.scipro.system.Lifecycle;

public class ForumMailModule extends AbstractModule {
    static final String FORUM_RELATIVE_URL = "forum/mail";

    @Override
    protected void configure() {
        requireBinding(MailEventService.class);

        bind(ForumMailRepository.class).to(ForumMailRepositoryImpl.class);
        bind(ForumMailProjectRepository.class).to(ForumMailProjectRepositoryImpl.class);
        bind(ForumMailGroupRepository.class).to(ForumMailGroupRepositoryImpl.class);
        bind(ForumMailService.class).to(ForumMailServiceImpl.class);
        bind(ForumMailSettingsService.class).to(ForumMailSettingsServiceImpl.class);
        bind(ForumMailReader.class).to(IMAPReader.class);
        bind(MailContentParser.class).to(ForumMailFormatterImpl.class);
        bind(ForumMailFormatter.class).to(ForumMailFormatterImpl.class);
        bind(SendForumMail.class).asEagerSingleton();
        bind(UserProfileService.class).to(UserProfileServiceImpl.class);
        bind(MailHandler.class).to(ReadForumMail.class);
        bind(GeneralSystemSettingsService.class).to(GeneralSystemSettingsServiceImpl.class);
        Multibinder.newSetBinder(binder(), Lifecycle.class).addBinding()
                .to(ForumMailWorkerSchedule.class);
    }
}
