package se.su.dsv.scipro.forummail;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@EqualsAndHashCode(callSuper = true)
@Data
@Table(name="forum_mail_settings")
@Entity
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class ForumMailSettings extends DomainObject {

    @Id
    private Long id;

    @Basic
    private String host;

    @Basic
    private int port;

    @Basic
    private String replyAddress;

    @Basic
    private String password;

    @Basic
    private String account;

    @Basic(optional = false)
    private boolean enabled = false;

    public ForumMailSettings(long id) {
        this.id = id;
    }

    public ForumMailSettings() {
    }

    public boolean isEnabled() {
        return enabled;
    }

    public String getReplyAddress() {
        return replyAddress;
    }

    public String getAccount() {
        return account;
    }
}
