package se.su.dsv.scipro.grading;

import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "grade")
@EqualsAndHashCode
public class Grade {

    @javax.persistence.Id
    @GeneratedValue
    private Long id;

    @OneToOne(optional = false)
    private Project project;

    @Basic(optional = true)
    private String value;

    @ManyToOne(optional = false)
    @JoinColumn(name = "reportedBy")
    private User reportedBy;

    @Basic(optional = false)
    @Temporal(TemporalType.DATE)
    private Date reportedOn;

    protected Grade() { } // JPA

    public Grade(final Project project) {
        this.project = project;
    }

    public Long getId() {
        return id;
    }

    public Project getProject() {
        return project;
    }

    void setReportedBy(final User reportedBy) {
        this.reportedBy = reportedBy;
    }

    void setReportedOn(final Date reportedOn) {
        this.reportedOn = reportedOn;
    }

    void setValue(final String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public User getReportedBy() {
        return reportedBy;
    }

    public Date getReportedOn() {
        return reportedOn;
    }
}
