package se.su.dsv.scipro.grading;

import com.mysema.query.jpa.impl.JPAQuery;
import scala.Option;
import se.su.dsv.scipro.project.Project;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

class GradeRepositoryImpl implements GradeRepository {
    private final Provider<EntityManager> em;

    @Inject
    GradeRepositoryImpl(final Provider<EntityManager> em) {
        this.em = em;
    }

    @Override
    public Grade save(final Grade grade) {
        return em.get().merge(grade);
    }

    @Override
    public void delete(final Grade grade) {
        em.get().remove(grade);
    }

    @Override
    public Option<Grade> get(final Project project) {
        JPAQuery query = new JPAQuery(em.get());
        Grade grade = query.from(QGrade.grade).where(QGrade.grade.project.eq(project)).singleResult(QGrade.grade);
        return Option.apply(grade);
    }
}
