package se.su.dsv.scipro.group;

import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectService;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;

public class GroupFacadeImpl implements GroupFacade {

    @Inject
    private ProjectService projectService;

    @Override
    public boolean isSupervisorOrFollower(final Group group, final User user) {
        if (group.getUser().equals(user)){
            return true;
        }
        for (Project project : group.getProjects()){
            if (projectService.isSupervisorOrFollower(project, user)){
                return true;
            }
        }
        return false;
    }

}