package se.su.dsv.scipro.mail;

import com.sun.mail.smtp.SMTPMessage;
import org.slf4j.Logger;

import javax.mail.SendFailedException;
import java.util.Arrays;

class Failure extends SMTPMailResult {
    private final SendFailedException exception;

    public Failure(final SMTPMessage message, final SendFailedException exception) {
        super(message);
        this.exception = exception;
    }

    @Override
    public void log(final Logger logger) {
        logger.info("Failed to deliver the mail to all recipients. Specified recipients: " + Arrays.toString(getAllRecipients()));
        if (exception.getValidSentAddresses() != null) {
            logger.info("Delivered to: " + Arrays.toString(exception.getValidSentAddresses()));
        }
        if (exception.getValidUnsentAddresses() != null) {
            logger.warn("Could not deliver to: " + Arrays.toString(exception.getValidUnsentAddresses()));
        }
        if (exception.getInvalidAddresses() != null) {
            logger.error("Invalid email found: " + Arrays.toString(exception.getInvalidAddresses()));
        }
    }
}
