package se.su.dsv.scipro.mail;

import lombok.Data;
import se.su.dsv.scipro.system.FilteredService;
import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Date;

public interface MailEventService extends GenericService<MailEvent, Long>,
        FilteredService<MailEvent, Long, MailEventService.Filter> {
    Iterable<MailEvent> findUnsent();

    @Data
    @SuppressWarnings("PMD.UnusedPrivateField")
    class Filter implements Serializable {
        private User user;
        private String subject;
        private Date sentAfter;
        private Date sentBefore;
    }
}

