package se.su.dsv.scipro.match;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

@Data
@Entity
@Table(name = "applicationperiodexemption")
@EqualsAndHashCode(of = {"applicationperiodexemptionId", "until"})
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class ApplicationPeriodExemption implements Serializable {
    @EmbeddedId
    private ApplicationPeriodExemptionId applicationperiodexemptionId = new ApplicationPeriodExemptionId();

    @MapsId("studentId")
    @ManyToOne(optional = false)
    @JoinColumn(name = "user_id")
    private User user;

    @MapsId("applicationPeriodId")
    @ManyToOne(optional = false)
    @JoinColumn(name = "applicationPeriodId")
    private ApplicationPeriod applicationPeriod;

    @NotNull
    private Date start;

    @NotNull
    private Date until;

    private String comment;

    @ManyToOne(optional = false)
    private User grantedBy;

    @NotNull
    private Date grantedOn;

    public ApplicationPeriodExemption() {}

    public ApplicationPeriodExemption(User student, ApplicationPeriod applicationPeriod) {
        this.user = student;
        this.applicationPeriod = applicationPeriod;
    }
}
