package se.su.dsv.scipro.match;

import com.mysema.query.types.expr.BooleanExpression;
import se.su.dsv.scipro.system.AbstractServiceImpl;
import se.su.dsv.scipro.system.ProjectType;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;

class ApplicationPeriodProjectTypeServiceImpl extends AbstractServiceImpl<ApplicationPeriodProjectType, ApplicationPeriodProjectTypeId> implements ApplicationPeriodProjectTypeService {
    @Inject
    ApplicationPeriodProjectTypeServiceImpl(Provider<EntityManager> em) {
        super(em, ApplicationPeriodProjectType.class, QApplicationPeriodProjectType.applicationPeriodProjectType);
    }

    @Override
    public ApplicationPeriodProjectType findOne(ApplicationPeriod applicationPeriod, ProjectType projectType) {
        return findOne(byApplicationPeriod(applicationPeriod).and(byProjectType(projectType)));
    }

    public static BooleanExpression byApplicationPeriod(ApplicationPeriod applicationPeriod) {
        return QApplicationPeriodProjectType.applicationPeriodProjectType.applicationPeriod.eq(applicationPeriod);
    }

    public static BooleanExpression byProjectType(ProjectType projectType) {
        return QApplicationPeriodProjectType.applicationPeriodProjectType.projectType.eq(projectType);
    }
}
