package se.su.dsv.scipro.match;

import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import java.util.Collection;
import java.util.List;

public interface ApplicationPeriodService extends GenericService<ApplicationPeriod, Long> {
	List<ApplicationPeriod> getCurrentPeriods();
    List<ApplicationPeriod> getCurrentPeriods(final User student);
    Collection<ApplicationPeriod> getPreviousPeriods(ApplicationPeriod applicationPeriod, int limit);
    ApplicationPeriod getCurrentPeriod(final ProjectType pc);
    ApplicationPeriod getCurrentPeriod(final ProjectType pc, final User student);
    ApplicationPeriod getPreviousPeriodByProjectType(ProjectType projectType);
    boolean courseStartHasPassed(final ApplicationPeriod ap);
    boolean endDateIsReached(final ApplicationPeriod ap);
    boolean isOpen(final ApplicationPeriod ap);
    boolean hasOpenExemption(final ApplicationPeriod ap, final User student);
    boolean hasExemption(User user, ApplicationPeriod ap);
    boolean doesPeriodOverlap(ApplicationPeriod newPeriod);

}
