package se.su.dsv.scipro.match;

import org.springframework.data.domain.Pageable;

import javax.inject.Inject;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class IdeaFacade implements Serializable {

    @Inject
    TargetService targetService;

    @Inject
    IdeaService ideaService;

    public Iterable<Idea> findIdeasPossibleToMatch(ApplicationPeriod applicationPeriod, IdeaService.Filter params, Pageable pageable) {
        params.setPublished(true);
        Iterable<Idea> ideas = ideaService.findAll(params);
        List<Idea> ideasWithinLimits = new ArrayList<>();
        for (Idea idea : ideas) {
            if (targetService.hasTargetsLeft(applicationPeriod, idea.getMatch().getSupervisor(), idea.getProjectType())) {
                ideasWithinLimits.add(idea);
            }
        }
        return ideaService.findAllInList(ideasWithinLimits, pageable);
    }

    public int countIdeasPossibleToMatch(ApplicationPeriod applicationPeriod, IdeaService.Filter params) {
        params.setPublished(true);
        Iterable<Idea> ideas = ideaService.findAll(params);
        List<Idea> ideasWithinLimits = new ArrayList<>();
        for (Idea idea : ideas) {
            if (targetService.hasTargetsLeft(applicationPeriod, idea.getMatch().getSupervisor(), idea.getProjectType())) {
                ideasWithinLimits.add(idea);
            }
        }
        return ideasWithinLimits.size();
    }
}
