package se.su.dsv.scipro.match;

import lombok.AccessLevel;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "target")
@EqualsAndHashCode
@Getter
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class Target implements Serializable {
    @EmbeddedId
    @Getter(AccessLevel.NONE)
    private TargetId targetId = new TargetId();

    @MapsId("userId")
    @ManyToOne
    @JoinColumn(name = "user_id")
    private User user;

    @MapsId("applicationPeriodId")
    @ManyToOne
    @JoinColumn(name = "applicationPeriodId")
    private ApplicationPeriod applicationPeriod;

    @MapsId("projectTypeId")
    @ManyToOne
    @JoinColumn(name = "projectTypeId")
    private ProjectType projectType;

    @Setter
    private int target;

    protected Target() {}

    public Target(User user, ApplicationPeriod applicationPeriod, ProjectType projectType) {
        this.user = user;
        this.applicationPeriod = applicationPeriod;
        this.projectType = projectType;
    }
}
