package se.su.dsv.scipro.milestones.service;

import lombok.Getter;
import lombok.Setter;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.milestones.dataobjects.Milestone;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectStatus;
import se.su.dsv.scipro.system.GenericService;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

public interface MileStoneService extends GenericService<Milestone, Long> {

    long countProjectMilestones(Project project, boolean confirmed);

    long countMileStones(Project project, User student, boolean confirmed);

    void setConfirmed(Project project, MilestoneActivityTemplate activity, boolean confirmed);

    void setConfirmed(Project project, User student, MilestoneActivityTemplate activity, boolean confirmed);

    boolean isConfirmed(Project project, MilestoneActivityTemplate activity);

    boolean isConfirmed(Project project, User student, MilestoneActivityTemplate activity);

    Milestone getMileStone(Project project, MilestoneActivityTemplate activity);

    Milestone getMileStone(Project project, User student, MilestoneActivityTemplate activity);

    long countCompletedMileStones(MilestoneActivityTemplate activity, Filter filter);

    long countCompletedMileStones(MilestoneActivityTemplate activity, Filter filter, ProjectType projectType);

    Iterable<Milestone> findCompletedMilestones(MilestoneActivityTemplate activity, Filter filter, Pageable pageable);

    @Getter
    @Setter
    @SuppressWarnings("PMD.UnusedPrivateField")
    class Filter implements Serializable {
        private Collection<ProjectType> projectTypes = new ArrayList<>();
        private Date projectStartedAfter;
        private Date projectStartedBefore;
        private Date mileStoneCompletedBefore = new Date();
        private Collection<ProjectStatus> projectStatuses = new ArrayList<>();
    }
}
