package se.su.dsv.scipro.milestones.service;

import lombok.Data;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectStatus;
import se.su.dsv.scipro.system.ProjectType;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.List;

public interface MilestoneStatisticsService {
    Long median(Filter filter);
    Long countCompletedBoth(Filter filter);
    Long countNotCompletedBoth(Filter filter);

    List<Project> getProgressedProjects(MilestoneActivityTemplate completed, MilestoneActivityTemplate notCompleted, Pageable pageRequest);
    long countProgressedProjects(MilestoneActivityTemplate completed, MilestoneActivityTemplate notCompleted);

    @Data
    @SuppressWarnings({"PMD.UnusedPrivateField", "UnusedDeclaration"})
    class Filter implements Serializable {
        private Date createdAfter;
        private Date createdBefore;
        private Collection<ProjectType> projectTypes;
        private Collection<ProjectStatus> statuses;
        private User headSupervisor;
        private MilestoneActivityTemplate firstMilestone;
        private MilestoneActivityTemplate secondMilestone;
    }
}
