package se.su.dsv.scipro.notifications.dataobject;

import se.su.dsv.scipro.group.Group;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.ManyToOne;

@Entity
public class GroupEvent extends NotificationEvent {

    public void setEvent(Event event) {
        this.event = event;
    }

    public enum Event {
        MESSAGE_THREAD_CREATED, MESSAGE_THREAD_REPLY
    }

    public Group getGroup() {
        return group;
    }

    @ManyToOne
    private Group group;

    @Enumerated(EnumType.STRING)
    private Event event;

    public GroupEvent() {
        super(Notification.Type.GROUP);
    }

    public void setGroup(Group group) {
        this.group = group;
    }

    @Override
    public Enum getEvent() {
        return event;
    }

    @Override
    protected String getEntityTitle() {
        return group.getTitle();
    }

    @Override
    public boolean hasEntity() {
        return group != null;
    }

    @Override
    public DomainObject getEntity() {
        return group;
    }
}
