package se.su.dsv.scipro.notifications.interfaces.impl;

import se.su.dsv.scipro.notifications.dataobject.PeerRequestEvent;
import se.su.dsv.scipro.peer.PeerRequest;

import java.text.MessageFormat;

public class PeerRequestFormatter extends AbstractEventFormatter<PeerRequestEvent> {

    PeerRequestFormatter(NotificationMailFormatterImpl formatter) {
        super(formatter);
    }

    @Override
    public String format(PeerRequestEvent event) {
        PeerRequest request = event.getRequest();

        String date = formatter.getDateString(request.getDateCreated());
        String requester = formatUser(request.getRequester());
        String title = request.getProject().getTitle();
        String level = request.getProject().getProjectType().getName();
        String supervisor = formatUser(request.getProject().getHeadSupervisor());

        // Cant use event.name() since that would mean same formatting as for peer reviews which has different info
        String property = getProperty("PEER_REQUEST");
        return MessageFormat.format(property,
                date,
                requester,
                title,
                level,
                supervisor);
    }
}
