package se.su.dsv.scipro.peer;

import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Comparator;

@Getter
@Setter
@ToString(exclude = {"commentThread"})
@Entity
@Table(name = "comment")
@Cacheable(true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class Comment extends DomainObject {
    @Id
    @GeneratedValue
    @Setter(AccessLevel.NONE)
    private Long id;

    @ManyToOne(optional = false)
    private User creator;

    @Lob
    private String comment;

    @ManyToOne(optional = false)
    private CommentThread commentThread;

    protected Comment() {
    }

    public Comment(final User creator, final CommentThread commentThread) {
        this.creator = creator;
        this.commentThread = commentThread;
    }

    public static class ByDateCreatedComparator implements Comparator<Comment>, Serializable {
        @Override
        public int compare(Comment o1, Comment o2) {
            return o1.getDateCreated().compareTo(o2.getDateCreated());
        }
    }
}
