package se.su.dsv.scipro.peer;

import lombok.Getter;
import lombok.Setter;
import org.springframework.data.domain.Pageable;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.*;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.List;

public interface PeerReviewService extends GenericService<PeerReview, Long>, FilteredService<PeerReview, Long, PeerReviewService.Filter> {
    List<PeerReview> findByReviewerAndProject(User student, Project project);
    List<PeerReview> findAllCompleted(Pageable pageable);
    List<PeerReview> findInProgressReviews(User student, Project project);
    List<PeerReview> findAllReviewsInProgress();
    List<PeerReview> findReceivedCompletedReviews(Project project);
    List<PeerReview> findCompletedReviews(Project project);
    Long countByStatus(PeerReview.ReviewStatus status);
    Long countByStatus(PeerReview.ReviewStatus status, Filter filter);
    Long countByStatus(PeerReview.ReviewStatus status, ProjectType type, Filter filter);
    Long countByStatusAndNoCheckListTemplate(Filter filter, PeerReview.ReviewStatus status);

    @Getter
    @Setter
    @SuppressWarnings({"PMD.UnusedPrivateField", "UnusedDeclaration"})
    class Filter implements Serializable {
        private User supervisor;
        private User author;
        private Project authorProject;
        private Collection<PeerReview.ReviewStatus> statuses;
        private Date createdAfter;
        private Date createdBefore;
        private Collection<ProjectType> projectTypes;
        private Language language;
    }
}
