package se.su.dsv.scipro.phd;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@Entity
@Getter
@EqualsAndHashCode(callSuper = true)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class AnnualReview extends DomainObject {
    @Id
    @GeneratedValue
    private Long id;

    @OneToOne(optional = false, cascade = CascadeType.ALL)
    private FileDescription annualReview;

    @ManyToOne(optional = false)
    private StudyPlan studyPlan;

    protected AnnualReview() {}

    AnnualReview(FileDescription annualReview, StudyPlan studyPlan) {
        this.annualReview = annualReview;
        this.studyPlan = studyPlan;
    }
}