package se.su.dsv.scipro.phd;

import com.mysema.query.jpa.impl.JPAQuery;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class AnnualReviewServiceImpl implements AnnualReviewService {

    private final Provider<EntityManager> em;

    @Inject
    public AnnualReviewServiceImpl(Provider<EntityManager> em) {
        this.em = em;
    }

    @Override
    public List<StudyPlan> findStudyPlansWithoutAnnualReviewThisYear() {
        QStudyPlan sp = QStudyPlan.studyPlan;
        return new JPAQuery(em.get())
                .from(sp)
                .where(sp.annualReviews.any().dateCreated.after(oneYearAgo()).not())
                .list(sp);
    }

    private Date oneYearAgo() {
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.YEAR, -1);
        return calendar.getTime();
    }
}
