package se.su.dsv.scipro.phd;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import javax.persistence.*;
import java.util.Date;

@Data
@EqualsAndHashCode(of = "id", callSuper = false)
@Entity
@Table(name = "department_service")
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class DepartmentService extends DomainObject {

    @Id
    @GeneratedValue
    private Long id;

    @ManyToOne
    private User user;

    @Basic(optional = true)
    private String description;

    @Basic(optional = false)
    private Integer hours;

    @Basic(optional = false)
    private Date dateStarted;

    @Basic(optional = false)
    private Date dateEnded;

    public DepartmentService(User user) {
        this.user = user;
    }

    protected DepartmentService() {

    }

}
