package se.su.dsv.scipro.report;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.persistence.Basic;
import javax.persistence.MappedSuperclass;
import javax.validation.constraints.Min;

@Getter
@ToString
@EqualsAndHashCode(callSuper = true)
@MappedSuperclass
@SuppressWarnings("PMD.UnusedPrivateField")
public abstract class AbstractGradingCriterion extends AbstractCriterion {

    @Basic(optional = false)
    @Min(0)
    protected int pointsRequiredToPass;

    @Basic
    @Setter
    private boolean fx = true;

    protected AbstractGradingCriterion() {

    }

    protected AbstractGradingCriterion(String title, int sortOrder, int pointsRequiredToPass) {
        super(title, sortOrder);
        this.pointsRequiredToPass = pointsRequiredToPass;
    }

    public abstract boolean isProjectCriterion();

    public abstract boolean isIndividualCriterion();

    public abstract int getMaxPoints();

    public abstract String getDescription();
}
