package se.su.dsv.scipro.report;


import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.*;

@Data
@Entity
@Table(name = "grading_criterion_point_template")
@EqualsAndHashCode(callSuper = true)
public class GradingCriterionPointTemplate extends AbstractGradingCriterionPoint {

    @ManyToOne(optional = false)
    private GradingCriterionTemplate gradingCriterionTemplate;

    @Override
    public int compareTo(AbstractGradingCriterionPoint abstractGradingCriterionPoint) {
        return this.getPoint().compareTo(abstractGradingCriterionPoint.getPoint());
    }

    public static class Builder {
        private final GradingCriterionPointTemplate instance = new GradingCriterionPointTemplate();

        public Builder point(Integer point) {
            instance.setPoint(point);
            return this;
        }

        public Builder description(String description) {
            instance.setDescription(description);
            return this;
        }

        public GradingCriterionPointTemplate build() {
            return instance;
        }
    }
}
