package se.su.dsv.scipro.report;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;

@EqualsAndHashCode(callSuper = false, of = "id")
@Entity
@Table(name = "report")
@Inheritance(strategy = InheritanceType.JOINED)
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public abstract class Report extends DomainObject {
    @Id
    @GeneratedValue
    @Getter
    private Long id;

    @Basic(optional = false)
    @Getter
    private boolean submitted = false;

    public abstract boolean isFinished();

    public void submit() {
        if (!isFinished()) {
            throw new IllegalStateException("Report is not finished: you need to score and give feedback to every criteria");
        }
        submitted = true;
    }
}
