package se.su.dsv.scipro.report;

import java.util.ArrayList;
import java.util.List;

public class ReviewerBachelorGradeCalculator extends AbstractBachelorGradeCalculator {

    private final SupervisorGradingReport supervisorGradingReport;

    public ReviewerBachelorGradeCalculator(SupervisorGradingReport supervisorGradingReport) {
        this.supervisorGradingReport = supervisorGradingReport;
    }

    @Override
    public Iterable<? extends GradingCriterion> getGradingCriteria(GradingReport gradingReport) {
        List<GradingCriterion> criteria = new ArrayList<>(gradingReport.getGradingCriteria());
        criteria.addAll(supervisorGradingReport.getIndividualCriteria());
        return criteria;
    }
}
