package se.su.dsv.scipro.security.auth;

import javax.inject.Inject;
import java.util.Set;

class AuthenticationServiceImpl implements AuthenticationService {
    private final Set<AuthenticationProvider> authenticationProviders;

    @Inject
    AuthenticationServiceImpl(final Set<AuthenticationProvider> authenticationProviders) {
        this.authenticationProviders = authenticationProviders;
    }

    @Override
    public boolean authenticate(final Credentials credentials) {
        for (AuthenticationProvider authenticationProvider : authenticationProviders) {
            if (authenticationProvider.authenticate(credentials)) {
                return true;
            }
        }
        return false;
    }
}
