package se.su.dsv.scipro.system;

import com.mysema.query.jpa.impl.JPAQuery;
import com.mysema.query.types.EntityPath;

import javax.inject.Provider;
import javax.persistence.EntityManager;

public class AbstractRepository {

    private final Provider<EntityManager> em;

    protected AbstractRepository(Provider<EntityManager> em) {
        this.em = em;
    }

    protected JPAQuery from(EntityPath<?>... paths) {
        return new JPAQuery(em.get()).from(paths);
    }

    protected EntityManager em() {
        return em.get();
    }
}
