package se.su.dsv.scipro.system;

import com.mysema.query.types.Predicate;
import org.springframework.data.domain.Pageable;

import java.io.Serializable;
import java.util.List;

public interface GenericService<T, ID extends Serializable> {

    <S extends T> S save(S entity);
	T findOne(ID id);
	void delete(ID id);
    void delete(T entity);

	long count();

    List<T> findAll();
    List<T> findAll(Pageable pageable);

    long count(Predicate predicate);
    T findOne(Predicate predicate);
    List<T> findAll(Predicate predicate);
    List<T> findAll(Predicate predicate, Pageable pageable);
}
