package se.su.dsv.scipro.system;

import javax.inject.Inject;
import javax.inject.Provider;
import javax.persistence.EntityManager;
import java.util.List;

public class ResearchAreaServiceImpl extends AbstractServiceImpl<ResearchArea,Long> implements ResearchAreaService {
    @Inject
    public ResearchAreaServiceImpl(Provider<EntityManager> em) {
        super(em, ResearchArea.class, QResearchArea.researchArea);
    }

    @Override
    public ResearchArea updateExternalResearchArea(Long identifier, String name) {
        ResearchArea ra = new ResearchArea();
        if (identifier != null) {
            ResearchArea existing = findOne(QResearchArea.researchArea.identifier.eq(identifier));
            if (existing != null) {
                ra = existing;
            } else {
                ra.setIdentifier(identifier);
            }
        }
        ra.setTitle(name);
        return save(ra);
    }

    @Override
    public List<ResearchArea> findNotDeleted() {
        return findAll(QResearchArea.researchArea.deleted.isFalse());
    }
}
