package se.su.dsv.scipro.util;

public class Pair<H, T> {

    private final H head;

    private final T tail;

    public Pair(H head, T tail) {
        this.head = head;
        this.tail = tail;
    }

    public H getHead() {
        return head;
    }

    public T getTail() {
        return tail;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Pair<?, ?> pair = (Pair<?, ?>) o;

        return !(head != null ? !head.equals(pair.head) : pair.head != null) && !(tail != null ? !tail.equals(pair.tail) : pair.tail != null);

    }

    @Override
    public int hashCode() {
        int result = head != null ? head.hashCode() : 0;
        result = 31 * result + (tail != null ? tail.hashCode() : 0);
        return result;
    }
}
