package se.su.dsv.scipro.util;

import java.io.InputStream;
import java.util.Properties;

public final class PropsUtils {
    private PropsUtils() {
    }

    /**
     * Load a properties file from the classpath
     *
     * @param propsName .
     * @return Properties
     * @throws Exception
     */
    public static Properties load(String propsName) throws Exception {
        return load(propsName, new Properties());
    }

    /**
     * Loads the properties from the specified file into the given properties map.
     *
     * @param propertyFile .
     * @param properties   .
     * @return .
     * @throws Exception
     */
    public static Properties load(String propertyFile, Properties properties) throws Exception {
        InputStream in = Thread.currentThread().getContextClassLoader().getResourceAsStream(propertyFile);
        properties.load(in);
        return properties;
    }
}