package se.su.dsv.scipro.workerthreads;

import java.util.concurrent.TimeUnit;

class RepeatingSchedule extends Schedule {
    private final long period;
    private final TimeUnit timeUnit;

    RepeatingSchedule(final long period, final TimeUnit timeUnit) {
        this.period = period;
        this.timeUnit = timeUnit;
    }

    @Override
    public long getDelay() {
        return period;
    }

    @Override
    public long getPeriod() {
        return period;
    }

    @Override
    public TimeUnit getTimeUnit() {
        return timeUnit;
    }
}
