package se.su.dsv.scipro.workerthreads;

import lombok.Data;
import lombok.EqualsAndHashCode;
import se.su.dsv.scipro.system.DomainObject;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name="worker_data")
@Cacheable(true)
@Data
@EqualsAndHashCode(callSuper = false)
@SuppressWarnings("PMD.UnusedPrivateField")
public class WorkerData extends DomainObject {
	public WorkerData() {
		lastSuccessfulRun = new Date(0);
	}

	@Id
	@GeneratedValue
	private Long id;
	
	@Column(unique=true, nullable=false)
	private String name;
	
	@Column(nullable=false)
	private Date lastRun=new Date();
	
	@Column(nullable=false)
	private Date lastSuccessfulRun;
	
	@PreUpdate
	@PrePersist
	public void updatelastSuccessfulRun() {
	    if( lastSuccessfulRun == null ) {
	      lastSuccessfulRun = new Date(0);
	    }
	}
}