CREATE TABLE IF NOT EXISTS `project_reviewer` (
  `project_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  PRIMARY KEY (`project_id`,`user_id`),
  KEY `FK_g7yryw3e0dtmuuvgw5qjhphjm` (`user_id`),
  KEY `FK_6aik0jd18kv3383fbt09xd0pi` (`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `project_reviewer`
  ADD CONSTRAINT `FK_6aik0jd18kv3383fbt09xd0pi` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`),
  ADD CONSTRAINT `FK_g7yryw3e0dtmuuvgw5qjhphjm` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`);

INSERT INTO `project_reviewer` (`user_id`, `project_id`) (
  SELECT `user_id` , `project_id`
  FROM `project_follower`
  WHERE `projectRole` = 'REVIEWER'
);

CREATE TABLE IF NOT EXISTS `project_cosupervisor` (
  `user_id` bigint(20) NOT NULL,
  `project_id` bigint(20) NOT NULL,
  PRIMARY KEY (`user_id`,`project_id`),
  KEY `FK_18x2poxkt8s2bw9kpr7vbmd5j` (`user_id`),
  KEY `FK_fj57t069dymdrnnhdxcnfvvnn` (`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `project_cosupervisor`
  ADD CONSTRAINT `FK_fj57t069dymdrnnhdxcnfvvnn` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`),
  ADD CONSTRAINT `FK_18x2poxkt8s2bw9kpr7vbmd5j` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`);

INSERT INTO `project_cosupervisor` (`user_id`, `project_id`) (
  SELECT DISTINCT `user_id` , `project_id`
  FROM `project_follower`
  WHERE `projectRole` = 'CO_SUPERVISOR'
);

DROP TABLE `project_follower`;