# trailing s in table name annoying, removing
RENAME TABLE `forum_threads` TO `forum_thread`;
RENAME TABLE `forum_posts` TO `forum_post`;
RENAME TABLE `forum_posts_read` TO `forum_post_read`;

# this is redundant, we can get it from the first posts user
ALTER TABLE `forum_thread` DROP FOREIGN KEY `FKAF97368B924F477B`;
# ALTER TABLE `forum_thread` DROP KEY `FKEDDC4F35924F477B`; this doesn't appear to exist
ALTER TABLE `forum_thread` DROP `user`;

# create new middle table for threads connected to projects
CREATE TABLE IF NOT EXISTS `project_thread` (
`id` bigint(20) NOT NULL AUTO_INCREMENT,
`project` bigint(20) NOT NULL,
PRIMARY KEY (`id`),
KEY (`project`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

ALTER TABLE `project_thread`
ADD CONSTRAINT FOREIGN KEY (`project`) REFERENCES `project` (`id`),
ADD CONSTRAINT FOREIGN KEY (`id`) REFERENCES `thread` (`id`);

INSERT INTO `project_thread`(`id`, `project`)
  SELECT `id`, `project` FROM `thread`;

# remove connection to project from thread
ALTER TABLE `thread` DROP FOREIGN KEY `thread_project`;
ALTER TABLE `thread` DROP KEY `thread_project`;
ALTER TABLE `thread` DROP `project`;

# point id to project_thread id instead of thread id
ALTER TABLE `forum_thread` DROP FOREIGN KEY `forum_threads_thread`;
ALTER TABLE `forum_thread` ADD CONSTRAINT FOREIGN KEY (`id`) REFERENCES `project_thread` (`id`);

# point id to project_thread id instead of thread id
ALTER TABLE `reviewer_thread` DROP FOREIGN KEY `reviewer_thread_thread`;
ALTER TABLE `reviewer_thread` ADD CONSTRAINT FOREIGN KEY (`id`) REFERENCES `project_thread` (`id`);

# drop old separate group tables
ALTER TABLE `group_thread`
DROP FOREIGN KEY `group_thread_ibfk_1`,
DROP FOREIGN KEY `group_thread_ibfk_2`,
DROP KEY `user`,
DROP KEY `project_group`;

ALTER TABLE `group_post`
DROP FOREIGN KEY `group_post_ibfk_1`,
DROP FOREIGN KEY `group_post_ibfk_2`,
DROP FOREIGN KEY `group_post_ibfk_3`,
DROP KEY `deleted`,
DROP KEY `user`,
DROP KEY `group_thread`,
DROP KEY `attachment`;

ALTER TABLE `group_thread_group_post`
DROP FOREIGN KEY `group_thread_group_post_ibfk_1`,
DROP FOREIGN KEY `group_thread_group_post_ibfk_2`,
DROP KEY `group_thread`,
DROP KEY `group_post`;

DROP TABLE `group_thread_group_post`;
DROP TABLE `group_post`;
DROP TABLE `group_thread`;

# create new group thread table
CREATE TABLE IF NOT EXISTS `project_group_thread` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `project_group` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY (`project_group`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

ALTER TABLE `project_group_thread`
ADD CONSTRAINT FOREIGN KEY (`project_group`) REFERENCES `project_group` (`id`),
ADD CONSTRAINT FOREIGN KEY (`id`) REFERENCES `thread` (`id`);
