###################################################################
#Master, 30 credits
###################################################################
SET @projectTypeName = 'Master';
SET @credit = 30;

###################################################################
SET @title = 'U1 Abstract';
###################################################################
SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the abstract of the thesis describes the problem, the research question, the choice and application of the research methods, the result, and conclusions and that it can be read and understood separately from the thesis.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U2 Introduction';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the thesis introduces the subject and problem of the thesis.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U3 Problem';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that a problem of general interest exists, that entirely or partially can be solved by answering the research question.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
  SELECT
    NOW(),
    NOW(),
    0,
    gct.id,
    @point,
    @description
  FROM grading_criterion_template gct
    INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
    INNER JOIN ProjectType pt on grt.projectType_id = pt.id
  WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U4 Research question';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: a clearly formulated and delimited research question that is of general interest. The student shall independently identify and formulate the research question. The research question should derive from the presented problem so that it is clear how the answer to the research question solves a portion or the entire problem.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: an innovative research question that provides necessary conditions so that the thesis could provide a significant scientific contribution.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U5 Scientific base';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the thesis provides a base for the topic of the thesis based on previous scientific research. The area within computer and system sciences to which the thesis contributes should also be named by presenting the scientific research to which the thesis refers.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that a deep and critical discussion is made about how the thesis builds upon previous scientific research.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 3;
SET @description = 'is also required: that a systematic and comprehensive literature study is presented that is the basis for placing and evaluating the research contribution of the thesis in a scientific context.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U6 Choice of research method';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the choice of a research strategy and research methods is clearly motivated and described, that alternative research strategies and methods that could be used to solve the research question are discussed, as well as that relevant ethical considerations are discussed.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that alternative, applicable research strategies and methods are comprehensively discussed and that a profound reasoning about the chosen strategies and methods is made, where the motives for choices made are clearly evident.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 3;
SET @description = 'is also required: that the choice of method is discussed in relation to the research strategies and methods that are used in current, related research studies that can be regarded as state-of-the-art.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U7 Application of research method';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the application of the chosen scientific strategies and methods are clearly described and that relevant ethical aspects are discussed.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that the application of research strategies and methods are done in accordance to the demands of said methods and strategies and that a clear argumentation exists for this.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 3;
SET @description = 'is also required: that there is a real depth to the data analysis.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U8 Result';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the results are of such a magnitude and quality and are presented in such a way that the research question can to some extent be answered.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that the results are of a considerable magnitude and high quality so that the research question can to a great extent be answered.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 3;
SET @description = 'is also required: that the results are well written and of considerable magnitude and high quality so that well grounded conclusions relevant for the research question can be made.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U9 Conclusions and discussion';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the research question has a clear answer, that the limitations in the composition of the thesis and their impact on the conclusions are discussed as well as how the results relate to previous research, that possible future research based on the study in the thesis is discussed, and that ethical and societal consequences of the conclusions in the thesis are discussed.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that the limitations of the study are thoroughly discussed and that a profound reasoning about possible and relevant future studies is made.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U10 Form, structure and language';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the thesis is divided into distinct and logical, coherent sections and fulfills the fundamental layout requirements and that the text is written with an adequate and professional language.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U11 Argumentation';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the argumentation is well grounded, logically coherent, concise, clear and easily understood.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U12 References and documentation';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that references in the thesis to previous research are made in a correct way according to a recognized reference system, that a clear listing of used references is made in the same system, that all quotes from previous work are clearly specified, and that relevant supplemental attachments are included.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'U13 Originality and significance';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the thesis contributes with significant or original research contributions, in the form of new ideas, artifacts, products, or services.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that the research contributions are of such quality that the thesis could be presented in a scientific workshop of good quality.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 3;
SET @description = 'is also required: that the research contributions are of such quality that the thesis could be presented at a scientific conference of good quality or that they could be a basis for useful solutions, for example commercializable products.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 4;
SET @description = 'is also required: that the research contributions are of such quality that the thesis could be presented in a scientific journal of good quality.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'Ö1 Opposition report';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the opposition report provides a short summary of the evaluated thesis, that it deliberates about the scientific basis, originality, significance, and formulation of the problem and research question, as well as that it contains clear suggestions for improvements.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 2;
SET @description = 'is also required: that the opposition report thoroughly and in a well-balanced way describes from numerous aspects the strengths and weaknesses of the evaluated thesis and that it offers clear and well-motivated suggestions for improvements.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'Ö2 Presentations';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that oral presentations are of sufficient quality, that they have been given on the assigned dates, and that the ability to orally defend one’s own thesis has been shown.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'Ö3 Participation in seminars and meetings';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the ability to orally discuss and provide constructive criticism regarding others’ work has been shown in seminars and meetings.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'Ö4 Deadlines';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that the ability to prepare and deliver material and presentations on time has been demonstrated at all the necessary occasions.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

###################################################################
SET @title = 'Ö5 Revisions after the final seminar';
###################################################################

SET @point = 0;
SET @description = NULL;
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;

SET @point = 1;
SET @description = 'is required: that only one smaller revision of the thesis is needed after the final seminar.';
INSERT INTO grading_criterion_point_template (`dateCreated`, `lastModified`, `version`, `gradingCriterionTemplate_id`, `point`, `description`)
SELECT
  NOW(),
  NOW(),
  0,
  gct.id,
  @point,
  @description
FROM grading_criterion_template gct
  INNER JOIN grading_report_template grt on gct.gradingReportTemplate_id = grt.id
  INNER JOIN ProjectType pt on grt.projectType_id = pt.id
WHERE pt.name = @projectTypeName AND grt.credits = @credit AND gct.title = @title;
