package se.su.dsv.scipro.`match`

import javax.inject.Inject

import com.google.common.eventbus.{EventBus, Subscribe}
import se.su.dsv.scipro.`match`.{ProjectStartedEvent => IdeaStartedEvent}
import se.su.dsv.scipro.activityplan.ActivityPlanFacade
import se.su.dsv.scipro.system.ProjectModule

import scala.collection.JavaConverters.iterableAsScalaIterableConverter

class AddActivityPlanOnProjectStart(val activityPlanFacade: ActivityPlanFacade) {
  @Inject def this(activityPlanFacade: ActivityPlanFacade, eventBus: EventBus) = {
    this(activityPlanFacade)
    eventBus.register(this)
  }

  @Subscribe def projectStarted(event: IdeaStartedEvent): Unit = {
    val idea = event.getIdea
    val applicationPeriod = idea.getApplicationPeriod
    val project = idea.getProject

    applicationPeriod.getApplicationPeriodProjectTypes.asScala
      .find(_.getProjectType == project.getProjectType)
      .flatMap(period => Option(period.getActivityPlanTemplate))
      .filter(_ => project.hasModule(ProjectModule.ACTIVITY_PLAN))
      .foreach { template =>
        activityPlanFacade.addActivitiesFromTemplate(project, template, applicationPeriod.getCourseStartDate)
      }
  }
}
