package se.su.dsv.scipro.notifications

import com.google.common.eventbus.Subscribe
import se.su.dsv.scipro.notifications.dataobject.{NotificationSource, PeerEvent}
import se.su.dsv.scipro.peer.{PeerRequestExpiredEvent, PeerRequestCancelledEvent}

trait PeerRequestNotifications {
  def notificationController: NotificationController

  @Subscribe def peerRequestCancelled(event: PeerRequestCancelledEvent) = {
    notificationController.notifyPeer(event.getPeerRequest, PeerEvent.Event.REQUEST_DELETED, new NotificationSource)
  }

  @Subscribe def peerRequestExpired(event: PeerRequestExpiredEvent) = {
    notificationController.notifyPeer(event.getPeerRequest, PeerEvent.Event.REQUEST_EXPIRED, new NotificationSource)
  }
}
