package se.su.dsv.scipro.forum;

import com.google.inject.AbstractModule;
import com.google.inject.Module;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.date.DateService;
import se.su.dsv.scipro.file.FileDescriptionService;
import se.su.dsv.scipro.notifications.NotificationController;
import se.su.dsv.scipro.notifications.NotificationService;
import se.su.dsv.scipro.test.GuiceTest;

@RunWith(MockitoJUnitRunner.class)
public abstract class ForumModuleTest extends GuiceTest {
    // TODO: Work towards removing these dependencies.
    @Mock
    private DateService dateService;
    @Mock
    private NotificationController notificationController;
    @Mock
    private NotificationService notificationService;
    @Mock
    private FileDescriptionService fileDescriptionService;

    @Override
    protected Module moduleUnderTest() {
        return new AbstractModule() {
            @Override
            protected void configure() {
                install(new ForumModule());
                bind(DateService.class).toInstance(dateService);
                bind(NotificationController.class).toInstance(notificationController);
                bind(NotificationService.class).toInstance(notificationService);
                bind(FileDescriptionService.class).toInstance(fileDescriptionService);
            }
        };
    }
}
