package se.su.dsv.scipro.forummail;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;

import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

@RunWith(MockitoJUnitRunner.class)
public class ForumMailWorkerTest {

    @Mock
    private ForumMailReader forumMailReader;
    @Mock
    private MailHandler mailHandler;
    @Mock
    private ForumMailSettingsService forumMailSettingsService;
    @InjectMocks
    private ForumMailWorker worker;

    @Test
    public void process_mails() throws Exception {
        ForumMailSettings settings = new ForumMailSettings();
        settings.setEnabled(true);
        when(forumMailSettingsService.getSettings()).thenReturn(settings);
        worker.doWork();
        verify(forumMailReader).accept(mailHandler);
    }
}
