package se.su.dsv.scipro.notifications;

import org.junit.Test;
import se.su.dsv.scipro.notifications.dataobject.Notification;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.IntegrationTest;

import javax.inject.Inject;

import static org.junit.Assert.assertFalse;

public class NotificationServiceImplTest extends IntegrationTest {

    @Inject
    private NotificationServiceImpl service;

    @Test
    public void test_mark_read() throws Exception {
        User user = save(User.builder().firstName("Bob").lastName("Sponge").emailAddress("bob@example.com").build());

        Notification n2 = create_notification(user, false);

        service.markRead(user);

        assertFalse(n2.isUnread());
    }

    private Notification create_notification(User user, boolean unread) {
        Notification notification = new Notification();
        notification.setUnread(unread);
        notification.setUser(user);
        return save(notification);
    }
}
