package se.su.dsv.scipro.peer;

import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.IntegrationTest;

import javax.inject.Inject;
import java.util.List;

import static org.junit.Assert.assertTrue;

public class CommentServiceImplTest extends IntegrationTest {

    @Inject
    private CommentServiceImpl commentService;
    private Comment comment;
    private CommentThread commentThread;

    @Before
    public void setUp() throws Exception {
        commentThread = save(new CommentThread(getCommentable()));
        comment = save(new Comment(save(User.builder().firstName("Bob").lastName("Sponge").emailAddress("bob@example.com").build()), commentThread));
    }

    @Test
    public void findByCommentThread() throws Exception {
        List<Comment> byCommentThread = commentService.findByCommentThread(commentThread);
        assertTrue(byCommentThread.contains(comment));
    }

    private Commentable getCommentable() {
        return new Commentable() {
            @Override
            public String getCommentKey() {
                return "any";
            }

            @Override
            public Long getId() {
                return 1L;
            }
        };
    }
}
