package se.su.dsv.scipro.report;

import org.junit.Test;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class GradingCriterionTest {
    @Test
    public void criterion_without_feedback_is_not_assessed() throws Exception {
        GradingCriterion gradingCriterion = createCriterion();
        gradingCriterion.setFeedback(null);

        assertFalse(gradingCriterion.isAssessed());
    }

    @Test
    public void criterion_with_empty_feedback_is_not_assessed() throws Exception {
        GradingCriterion gradingCriterion = createCriterion();
        gradingCriterion.setFeedback("");

        assertFalse(gradingCriterion.isAssessed());
    }

    @Test
    public void criterion_with_feedback_and_points_is_assessed() throws Exception {
        GradingCriterion gradingCriterion = createCriterion();
        gradingCriterion.setPoints(1);
        gradingCriterion.setFeedback("Feedback");

        assertTrue(gradingCriterion.isAssessed());
    }

    private GradingCriterion createCriterion() {
        GradingCriterion gradingCriterion = new ProjectGradingCriterion();
        gradingCriterion.setPoints(1);
        return gradingCriterion;
    }
}
