package se.su.dsv.scipro.report;

import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;
import static se.su.dsv.scipro.test.ObjectMother.*;

public class SupervisorGradingReportFactoryTest {

    private GradingReportTemplate gradingReportTemplate;

    @Before
    public void setUp() throws Exception {
        gradingReportTemplate = new GradingReportTemplate(BACHELOR, 30);
        List<GradingCriterionPointTemplate> gradingCriterionPointTemplates = new ArrayList<>();
        gradingCriterionPointTemplates.add(new GradingCriterionPointTemplate.Builder().point(1).description("Description").build());
        gradingReportTemplate.addProjectCriterion("Title", 1, gradingCriterionPointTemplates);
        gradingReportTemplate.addIndividualCriterion("Title", 1, gradingCriterionPointTemplates);
    }

    @Test
    public void only_includes_project_criterion() throws Exception {
        GradingReport reviewerReport = gradingReportTemplate.createSupervisorReport(SOME_PROJECT, SOME_USER);
        assertThat(reviewerReport.getGradingCriteria().size(), is(2));
    }
}
