package se.su.dsv.scipro.test;

import org.mockito.Mockito;
import se.su.dsv.scipro.system.DomainObject;

import java.lang.reflect.Field;

public final class DomainObjects {

    private DomainObjects() { }

    public static <T extends DomainObject> T injectId(T object, Long id) {
        try {
            for (Class<?> clazz = object.getClass(); clazz != null; clazz = clazz.getSuperclass()) {
                try {
                    Field idField = clazz.getDeclaredField("id");
                    idField.setAccessible(true);
                    idField.set(object, id);
                } catch (NoSuchFieldException ignored) {
                }
            }
        }
        catch (Exception ex) {
            object = Mockito.spy(object);
            Mockito.when(object.getId()).thenReturn(id);
            ex.printStackTrace();
        }
        return object;
    }

    public static <T> T copyAttributes(T to, T from) {
        for (Field field : from.getClass().getDeclaredFields()) {
            field.setAccessible(true);
            try {
                field.set(to, field.get(from));
            }
            catch (Exception ex) {
                //ex.printStackTrace();
            }
        }
        return to;
    }

    public static <T> boolean attributeEquals(T obj1, T obj2) {
        try {
            for (Field field : obj1.getClass().getDeclaredFields()) {
                field.setAccessible(true);
                if (!field.get(obj1).equals(field.get(obj2))) {
                    return false;
                }
            }
            return true;
        }
        catch (Exception ex) {
            return false;
        }
    }
}
