package se.su.dsv.scipro.integration.daisy;

import se.su.dsv.scipro.integration.daisy.workers.GradingCompletedMilestoneActivator;
import se.su.dsv.scipro.integration.daisy.workers.ProjectExporter;
import se.su.dsv.scipro.integration.daisy.workers.ProjectFinalizer;
import se.su.dsv.scipro.integration.daisy.workers.UserImportWorker;
import se.su.dsv.scipro.workerthreads.Scheduler;

import javax.inject.Inject;
import javax.inject.Provider;

class DaisyWorkerInitialization {
    @Inject
    DaisyWorkerInitialization(
            Scheduler scheduler,
            Provider<ProjectExporter> projectExporter,
            Provider<UserImportWorker> userImportWorker,
            Provider<ProjectFinalizer> projectFinalizer,
            Provider<GradingCompletedMilestoneActivator> gradingFinalizer) {
        scheduler.schedule("Export projects to daisy").runBy(projectExporter).dailyAt(1, 0);
        scheduler.schedule("Remote supervisor (and projects) bulk import").runBy(userImportWorker).dailyAt(1, 30);
        scheduler.schedule("Mark projects as completed").runBy(projectFinalizer).dailyAt(2, 0);
        scheduler.schedule("Mark the 'grading completed' milestone as completed").runBy(gradingFinalizer).dailyAt(2, 30);
    }
}
