import com.googlecode.flyway.core.Flyway;
import lombok.SneakyThrows;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.sql.DataSource;

public class DatabaseMigration implements ServletContextListener {
    @Override
    public void contextInitialized(ServletContextEvent sce) {
        migrateDatabase();
    }

    private void migrateDatabase() {
        Flyway flyway = new Flyway();
        flyway.setDataSource(getDataSource());
        flyway.setInitOnMigrate(true);
        flyway.migrate();
    }

    @SneakyThrows(NamingException.class)
    private DataSource getDataSource() {
        return InitialContext.doLookup("java:comp/env/jdbc/sciproDS");
    }

    @Override
    public void contextDestroyed(ServletContextEvent sce) {
    }
}
