package se.su.dsv.scipro.activityplan;

import org.apache.wicket.markup.html.form.upload.FileUpload;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.AbstractUploadForm;
import se.su.dsv.scipro.files.WicketProjectFileUpload;
import se.su.dsv.scipro.notifications.NotificationController;
import se.su.dsv.scipro.notifications.dataobject.NotificationSource;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectService;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

import static se.su.dsv.scipro.notifications.dataobject.ProjectEvent.Event.FILE_UPLOADED;

public class ActivityUploadForm extends AbstractUploadForm {
    @Inject
    private ActivityPlanFacade facade;
    @Inject
    private ProjectService projectService;
    @Inject
    private NotificationController notificationController;

    private final IModel<Activity> event;

    ActivityUploadForm(final IModel<Activity> event) {
        this.event = event;
    }

    @Override
    protected void onNewUpload(final FileUpload fileUpload) {
        Activity activity = event.getObject();
        facade.storeActivityUpload(new WicketProjectFileUpload(fileUpload, activity.getActivityPlan().getProject(), false), activity);

        Project project = projectService.findOne(activity.getActivityPlan().getProject().getId());

        PageParameters pp = new PageParameters();
        pp.add(PageParameterKeys.MAP.get(Project.class), String.valueOf(project.getId()));
        pp.add("id", "");

        NotificationSource source = new NotificationSource();
        source.setMessage(fileUpload.getClientFileName());
        notificationController.notifyProject(project, FILE_UPLOADED, source);
    }
}
