package se.su.dsv.scipro.activityplan;


import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAuthorMyProjects;
import se.su.dsv.scipro.project.pages.AbstractProjectDetailsPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.ProjectModule;

@Authorization(authorizedRoles={Roles.AUTHOR})
@ProjectModuleComponent(ProjectModule.ACTIVITY_PLAN)
public class ProjectActivityPlanPage extends AbstractProjectDetailsPage implements MenuHighlightAuthorMyProjects {
	
	public ProjectActivityPlanPage(final PageParameters pp){
		super(pp);
		if(getActiveProject() == null || getUser() == null) {
            throw new IllegalStateException("No valid project or user");
        }
		add(new ActivityPlanPanel("activityPlan", projectModel));
	}
}
