package se.su.dsv.scipro.activityplan;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.ModalWindowPlus;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorActivityTemplates;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorAllProjectsPage;
import se.su.dsv.scipro.util.PageParameterKeys;

import static se.su.dsv.scipro.security.auth.roles.Roles.SUPERVISOR;

@Authorization(authorizedRoles = {SUPERVISOR})
public class SupervisorActivityPlanTemplatesPage extends AbstractSupervisorAllProjectsPage implements MenuHighlightSupervisorActivityTemplates {

    private ModalWindowPlus modalWindowPlus;

    public SupervisorActivityPlanTemplatesPage(final PageParameters pp) {
        super(pp);

        modalWindowPlus = new ModalWindowPlus("dialog");
        add(modalWindowPlus);

        add(new ActivityPlanTemplateDataPanel("activityPlanTemplatePanel") {
            @Override
            public void onNewClick() {
                setResponsePage(SupervisorEditActivityTemplatePage.class);
            }

            @Override
            public void onTitleClick(IModel<ActivityPlanTemplate> clicked, AjaxRequestTarget target) {
                modalWindowPlus.setContent(new ActivityPlanTemplateDetailsPanel(modalWindowPlus.getContentId(), clicked));
                modalWindowPlus.show(target);
            }

            @Override
            public void onEditClick(IModel<ActivityPlanTemplate> clicked) {
                PageParameters pp = new PageParameters();
                pp.set(PageParameterKeys.MAP.get(ActivityPlanTemplate.class), clicked.getObject().getId());
                setResponsePage(SupervisorEditActivityTemplatePage.class, pp);
            }
        });
    }
}
