package se.su.dsv.scipro.activityplan;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorActivityTemplates;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorAllProjectsPage;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

public class SupervisorEditActivityTemplatePage extends AbstractSupervisorAllProjectsPage implements MenuHighlightSupervisorActivityTemplates {
    public static final String PANEL = "panel";
    @Inject
    private ActivityPlanTemplateService activityPlanTemplateService;

    public SupervisorEditActivityTemplatePage(PageParameters pp) {
        super(pp);
        if (pp.get(PageParameterKeys.MAP.get(ActivityPlanTemplate.class)).isNull()){
            add(new EditActivityTemplatePanel(PANEL, new DetachableServiceModel<>(activityPlanTemplateService, new ActivityPlanTemplate())));
        } else {
            add(new EditActivityTemplatePanel(PANEL, new DetachableServiceModel<>(activityPlanTemplateService, pp.get(PageParameterKeys.MAP.get(ActivityPlanTemplate.class)).toLong())));
        }
    }
}
