package se.su.dsv.scipro.admin.pages;

import org.apache.wicket.model.Model;
import se.su.dsv.scipro.admin.panels.AdminMailPanel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.system.User;

import java.util.Set;

@Authorization(authorizedRoles={Roles.ADMIN})
public class AdminMailPage extends AbstractAdminMailPage {

    public AdminMailPage() {
		add(new AdminMailPanel("newAdminMailPanel"));
	}

    public AdminMailPage(Set<User> users) {
        add(new AdminMailPanel("newAdminMailPanel", users));
    }

    public AdminMailPage(Set<User> users, String subject, String content) {
        add(new AdminMailPanel("newAdminMailPanel", users, Model.of(subject), Model.of(content)));
    }
}
