package se.su.dsv.scipro.checklists;

import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.checklist.Checklist;
import se.su.dsv.scipro.checklist.ChecklistService;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorActivityPlan;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyProjects;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorProjectDetailsPage;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;

import static se.su.dsv.scipro.security.auth.roles.Roles.SUPERVISOR;

@Authorization(authorizedRoles = {SUPERVISOR})
public class SupervisorViewChecklistPage extends AbstractSupervisorProjectDetailsPage
        implements MenuHighlightSupervisorMyProjects, MenuHighlightSupervisorActivityPlan {

    @Inject
    private ChecklistService checklistService;

    public SupervisorViewChecklistPage(PageParameters pp) {
        super(pp);
        Long checklistId = pp.get(PageParameterKeys.MAP.get(Checklist.class)).toLong();
        final IModel<Checklist> checklistModel = new DetachableServiceModel<>(checklistService, checklistId);
        add(new ChecklistQuestionPanel("questions", new CompoundPropertyModel<>(checklistModel)));
    }
}
