package se.su.dsv.scipro.components;

import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.util.visit.IVisit;
import org.apache.wicket.util.visit.IVisitor;

import java.util.Map;

/**
 * This class add to AjaxRequesttarget.add() all feddback panels that should be repaint
 * <p/>
 * Based on Apache Wicket Cookbook
 */
public class AjaxFeedbackPanelUpdater implements AjaxRequestTarget.IListener {
    @Override
    public void onBeforeRespond(Map<String, Component> map, final AjaxRequestTarget target) {
        target.getPage().visitChildren(FeedbackPanel.class, new IVisitor<FeedbackPanel, Void>() {
            @Override
            public void component(final FeedbackPanel feedback, IVisit visit) {
                if (feedback.getOutputMarkupId() && (feedback.anyMessage() || feedback.isVisibleInHierarchy())) {
                    target.add(feedback);
                }
            }
        });
    }

    @Override
    public void onAfterRespond(Map<String, Component> map, AjaxRequestTarget.IJavaScriptResponse response) {

    }
}