package se.su.dsv.scipro.components;

import org.apache.wicket.Component;
import org.apache.wicket.model.AbstractReadOnlyModel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.util.lang.Classes;

public class EnumModel<E extends Enum<E>> extends AbstractReadOnlyModel<String> {
    private final Component component;
    private final IModel<E> model;

    public EnumModel(final Component component, final IModel<E> model) {
        this.component = component;
        this.model = model;
    }

    @Override
    public String getObject() {
        E value = model.getObject();
        String resourceKey = Classes.simpleName(value.getDeclaringClass()) + '.' + value.name();
        return component.getString(resourceKey);
    }
}
