package se.su.dsv.scipro.components;

import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.behavior.AttributeAppender;
import org.apache.wicket.markup.ComponentTag;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

public class ModalWindowPlus extends Panel {

    public ModalWindowPlus(String id) {
        super(id);

        add(AttributeAppender.append("class", "modal"));
        setOutputMarkupId(true);

        Label title = new Label("title", ""); // Providing an initial model to prevent errors when there is a CompoundPropertyModel in the parent hierarchy
        title.setOutputMarkupId(true);
        add(title);
        WebMarkupContainer content = new WebMarkupContainer("body");
        content.setOutputMarkupId(true);
        add(content);
    }

    @Override
    protected void onComponentTag(ComponentTag tag) {
        checkComponentTag(tag, "div");
        super.onComponentTag(tag);
    }

    public void setTitle(String title) {
        setTitle(Model.of(title));
    }

    public void setTitle(IModel<String> title) {
        get("title").setDefaultModel(title);
    }

    public void show(AjaxRequestTarget target) {
        target.add(this);
        target.appendJavaScript(String.format("$('#%s').modal('show');", getMarkupId()));
    }

    public void close(AjaxRequestTarget target) {
        target.appendJavaScript(String.format("$('#%s').modal('hide');", getMarkupId()));
    }

    public String getContentId() {
        return "body";
    }

    public void setContent(Component component) {
        component.setOutputMarkupId(true);
        replace(component);
    }
}
