package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.springdata.SortOrderService;

public class SortOrderPanel<T> extends Panel {

    private final SortOrderService<T> orderService;
    private final IModel<T> objectModel;

    public SortOrderPanel(String id, IModel<T> model, SortOrderService<T> service) {
        super(id);

        this.orderService = service;
        this.objectModel = model;

        add(new AjaxLink<Void>(MOVE_UP) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                orderService.moveUp(objectModel.getObject());
                setResponsePage(getPage());
            }
        });
        add(new AjaxLink<Void>(MOVE_DOWN) {
            @Override
            public void onClick(AjaxRequestTarget target) {
                orderService.moveDown(objectModel.getObject());
                setResponsePage(getPage());
            }
        });
    }

    static final String MOVE_UP = "moveUp";
    static final String MOVE_DOWN = "moveDown";
}
