package se.su.dsv.scipro.components;

import org.apache.wicket.injection.Injector;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;
import se.su.dsv.scipro.misc.DaysService;

import javax.inject.Inject;
import java.util.Date;

public class WorkDaysModel extends LoadableDetachableModel<Date> {

    private final IModel<Date> model;
    private final int daysAhead;

    @Inject
    DaysService daysService;

    public WorkDaysModel(final IModel<Date> model, int daysAhead) {
        this.model = model;
        this.daysAhead = daysAhead;
    }

    @Override
    protected Date load() {
        Injector.get().inject(this);

        return daysService.workDaysAhead(model.getObject(), daysAhead);
    }

    @Override
    protected void onDetach() {
        model.detach();
    }
}
