package se.su.dsv.scipro.components.datatables;

import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator;
import org.apache.wicket.extensions.markup.html.repeater.data.table.export.AbstractExportableColumn;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.profile.UserLinkPanel;
import se.su.dsv.scipro.system.User;

public abstract class UserColumn<T, S> extends AbstractExportableColumn<T, S, String> {
    public UserColumn(final IModel<String> displayModel) {
        super(displayModel);
    }

    protected abstract IModel<User> getUser(IModel<T> rowModel);

    @Override
    public void populateItem(Item<ICellPopulator<T>> cellItem, String componentId, IModel<T> rowModel) {
        cellItem.add(new UserLinkPanel(componentId, getUser(rowModel)));
    }

    @Override
    public IModel<String> getDataModel(IModel<T> rowModel) {
        return new PropertyModel<>(getUser(rowModel), "fullName");
    }
}
