package se.su.dsv.scipro.dataproviders;

import lombok.EqualsAndHashCode;
import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;

@EqualsAndHashCode(callSuper = true)
public class PageAdapter extends PageRequest {

    private final SortParam<String> sort;

    public PageAdapter(final long offset, final long count, final SortParam<String> sort) {
        super(offset, count);
        this.sort = sort;
    }

    @Override
    public Sort getSort() {
        if (sort == null) {
            return null;
        }

        return new Sort(
                sort.isAscending() ? Sort.Direction.ASC : Sort.Direction.DESC,
                sort.getProperty());
    }
}
