package se.su.dsv.scipro.files;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.file.FileDescription;
import se.su.dsv.scipro.profile.UserLinkPanel;
import se.su.dsv.scipro.repository.panels.ViewAttachmentPanel;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.util.AjaxConfirmationLink;

public class FileDescriptionPanel extends GenericPanel<FileDescription> {



    public boolean deleteAllowed(){
        return false;
    }

    public void onDelete(AjaxRequestTarget target){
    }

    public FileDescriptionPanel(String id, final IModel<FileDescription> model) {
        super(id, model);

        add(new ViewAttachmentPanel(FILE, model, DateStyle.DATETIME));

        add(new UserLinkPanel(UPLOADER, new PropertyModel<User>(model, "uploader")));

        add(new AjaxConfirmationLink<Void>(DELETE, "Are you sure you want to delete the file?") {
            @Override
            public void onClick(AjaxRequestTarget target) {
                onDelete(target);
            }
            protected void onConfigure(){
                setVisibilityAllowed(deleteAllowed());
            }
        });
    }

    @Override
    protected void onConfigure() {
        setVisibilityAllowed(getModelObject() != null);
    }

    public static final String FILE = "file";
    public static final String UPLOADER = "uploader";
    public static final String DELETE = "delete";
}