package se.su.dsv.scipro.files;

import org.apache.wicket.markup.html.form.upload.FileUpload;
import se.su.dsv.scipro.file.ProjectFileUpload;
import se.su.dsv.scipro.project.Project;

public class WicketProjectFileUpload extends WicketFileUpload implements ProjectFileUpload {

    private final Project project;
    private final boolean deletable;

    public WicketProjectFileUpload(FileUpload fileUpload, Project project) {
        this(fileUpload, project, true);
    }

    public WicketProjectFileUpload(FileUpload fileUpload, Project project, boolean deletable) {
        super(fileUpload);
        this.project = project;
        this.deletable = deletable;
    }

    @Override
    public Project getProject() {
        return project;
    }

    @Override
    public boolean isDeletable() {
        return deletable;
    }

}
