package se.su.dsv.scipro.finalseminar;


import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.ResourceLink;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.components.DateLabel;
import se.su.dsv.scipro.grading.ReportPdfResource;
import se.su.dsv.scipro.report.Report;

import java.util.Date;

public class DownloadPdfReportPanel extends Panel {


    public static final String DOWNLOAD_PDF = "downloadPdf";
    public static final String PDF_LABEL = "pdfLabel";
    public static final String PDF_UPLOAD_DATE = "pdfUploadDate";

    public DownloadPdfReportPanel(String id, IModel<FinalSeminar> finalSeminar, final IModel<? extends Report> report, final ReportPdfResource reportPdfResource) {
        super(id, finalSeminar);

        ResourceLink<Report> resourceLink = new ResourceLink<Report>(DOWNLOAD_PDF, reportPdfResource) {
            @Override
            protected void onConfigure() {
                setVisibilityAllowed(report.getObject().isSubmitted());
            }
        };
        add(resourceLink);
        resourceLink.add(new Label(PDF_LABEL, reportPdfResource.getFileName()));
        resourceLink.add(new DateLabel(PDF_UPLOAD_DATE, new PropertyModel<Date>(report, "lastModified")));
    }
}
