package se.su.dsv.scipro.forum;

import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.file.FileUpload;
import se.su.dsv.scipro.forum.dataobjects.ProjectThread;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;

import java.util.Set;

public class ProjectForum implements Forum<ProjectThread> {
    private final ProjectForumService projectForumService;
    private final IModel<Project> projectModel;

    public ProjectForum(final ProjectForumService projectForumService, final IModel<Project> projectModel) {
        this.projectForumService = projectForumService;
        this.projectModel = projectModel;
    }

    @Override
    public ProjectThread createThread(final User user, final String subject, final String content, final Set<FileUpload> attachments) {
        Project project = projectModel.getObject();
        return projectForumService.createThread(project, user, subject, content, attachments);
    }

}
