package se.su.dsv.scipro.forum.pages;

import org.apache.wicket.RestartResponseException;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.util.string.StringValue;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.forum.pages.threaded.ProjectThreadedForumPage;
import se.su.dsv.scipro.forum.pages.threaded.ProjectViewForumThreadPage;
import se.su.dsv.scipro.project.pages.AbstractProjectDetailsPage;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.system.ProjectModule;
import se.su.dsv.scipro.util.PageParameterKeys;

@ProjectModuleComponent(ProjectModule.FORUM)
public class ProjectForumBasePage extends AbstractProjectDetailsPage {

    public ProjectForumBasePage(PageParameters pp) {
        super(pp);

        StringValue value = pp.get(PageParameterKeys.MAP.get(ForumThread.class));
        Long threadId = null;
        if(!value.isNull()) {
            threadId = value.toLongObject();
        }
        if(threadId==null) {
            throw new RestartResponseException(ProjectThreadedForumPage.class, pp);
        }
        throw new RestartResponseException(ProjectViewForumThreadPage.class, pp);
    }
}
