package se.su.dsv.scipro.forum.panels.threaded;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.forum.BasicForumService;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.forum.panels.AbstractReadStatePanel;
import se.su.dsv.scipro.session.SciProSession;

import javax.inject.Inject;

/**
 * @author : emil-siv
 * Date: 2013-07-01
 */
public class ThreadReadStatePanel extends AbstractReadStatePanel {

    @Inject
    private BasicForumService basicForumService;

    private final IModel<ForumThread> model;

    public ThreadReadStatePanel(String id, IModel<ForumThread> model) {
        super(id);
        this.model = model;
    }

    @Override
    protected boolean isRead() {
        return basicForumService.isThreadRead(SciProSession.get().getUser(), model.getObject());
    }

    @Override
    protected void toggleReadState(final AjaxRequestTarget target) {
        boolean read = isRead();
        basicForumService.setThreadRead(SciProSession.get().getUser(), model.getObject(), !read);

    }
}
