package se.su.dsv.scipro.grading;

import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import org.apache.wicket.model.Model;
import se.su.dsv.scipro.report.Report;

import java.util.Collections;

public class GradingReportPdfResource extends ReportPdfResource {

    private final GradingReportPdf gradingReportPdf;

    public GradingReportPdfResource(GradingReportPdf gradingReportPdf) {
        super(new Model<Report>());
        this.gradingReportPdf = gradingReportPdf;
    }

    @Override
    public JRDataSource getReportDataSource() {
        return new JRBeanCollectionDataSource(Collections.singleton(gradingReportPdf));
    }

    @Override
    protected String getTemplateName() {
        return "template.jrxml";
    }

    @Override
    public String getFileName() {
        return gradingReportPdf.getProjectTypeName() + "_grading_report_" + gradingReportPdf.getAuthorName() + "." + getExtension();
    }
}
