package se.su.dsv.scipro.grading;

import lombok.SneakyThrows;
import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import org.apache.wicket.model.IModel;
import org.wicketstuff.jasperreports.JRConcreteResource;
import org.wicketstuff.jasperreports.handlers.PdfResourceHandler;
import se.su.dsv.scipro.report.Report;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public abstract class ReportPdfResource extends JRConcreteResource<PdfResourceHandler> {

    private IModel<? extends Report> reportIModel;

    public ReportPdfResource(IModel<? extends Report> reportIModel) {
        super(new PdfResourceHandler());
        this.reportIModel = reportIModel;
    }

    @Override
    public Map<String, Object> getReportParameters() {
        return new HashMap<>();
    }

    @Override
    public JRDataSource getReportDataSource() {
        reportIModel.detach();
        return new JRBeanCollectionDataSource(Collections.singleton(reportIModel.getObject()));
    }

    @Override
    @SneakyThrows(JRException.class)
    public JasperReport getJasperReport() {
        return JasperCompileManager.compileReport(getClass().getClassLoader().getResourceAsStream(getTemplateName()));
    }

    protected abstract String getTemplateName();

    @Override
    public abstract String getFileName();
}
