package se.su.dsv.scipro.grading;

import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;

public class TemplatePanel extends Panel {

    public static final String BACHELOR_CONTAINER = "bachelorContainer";
    public static final String MASTER_15_CONTAINER = "master15Container";
    public static final String MASTER_30_CONTAINER = "master30Container";

    public TemplatePanel(String id, final IModel<Project> projectIModel) {
        super(id, projectIModel);
        final DegreeLevel degreeLevel = projectIModel.getObject().getProjectType().getDegreeLevel();
        final int credits = projectIModel.getObject().getCredits();

        add(new WebMarkupContainer(BACHELOR_CONTAINER) {
            @Override
            protected void onConfigure() {
                super.onConfigure();
                setVisibilityAllowed(degreeLevel.equals(DegreeLevel.FIRST_CYCLE));
            }
        });
        add(new WebMarkupContainer(MASTER_15_CONTAINER) {
            @Override
            protected void onConfigure() {
                super.onConfigure();
                setVisibilityAllowed(degreeLevel.equals(DegreeLevel.SECOND_CYCLE) && credits == ProjectType.HP_15);
            }
        });
        add(new WebMarkupContainer(MASTER_30_CONTAINER) {
            @Override
            protected void onConfigure() {
                super.onConfigure();
                setVisibilityAllowed(degreeLevel.equals(DegreeLevel.SECOND_CYCLE) && (credits == ProjectType.HP_30 || credits == 0));
            }
        });
    }

}
