package se.su.dsv.scipro.latestevents;

import lombok.Getter;
import se.su.dsv.scipro.system.DomainObject;
import se.su.dsv.scipro.system.User;

import java.io.Serializable;
import java.util.Date;

@Getter
@SuppressWarnings({"PMD.UnusedPrivateField", "PMD.SingularField"})
public class LatestEvent implements Serializable {

    public enum LatestEventType {
        FILES, FORUM
    }

    private Date date;

    private LatestEventType type;
    private User creator;
    private String title;
    private DomainObject domainObject;

    public LatestEvent(Date date, LatestEventType type, User creator, String title, DomainObject fileDescription) {
        this.date = date;
        this.type = type;
        this.creator = creator;
        this.title = title;
        this.domainObject = fileDescription;
    }
}
