package se.su.dsv.scipro.loginlogout.pages;

import org.apache.wicket.markup.html.link.ExternalLink;
import org.apache.wicket.request.Url;
import se.su.dsv.scipro.basepages.PublicPage;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.system.UserService;

import javax.inject.Inject;

public class LoginPage extends PublicPage {
    private static final String IDP_SU = "/Shibboleth.sso/Login?entityID=https://idp.it.su.se/idp/shibboleth&target=";

    @Inject
    private UserService userService;
    @Inject
    private GeneralSystemSettingsService systemSettingsService;

    public LoginPage() throws Exception {
        if (userService.count() == 0) {
            setResponsePage(FirstTimeRegistrationPage.class);
        }
        else if (!systemSettingsService.getGeneralSystemSettingsInstance().isShowSingleSignOn()) {
            setResponsePage(LocalLogInPage.class);
        }

        initComponents();
	}

    private void initComponents() {
        CharSequence relativeHomePage = urlFor(getApplication().getHomePage(), getPageParameters());
        String absoluteReturnURL = getRequestCycle().getUrlRenderer().renderFullUrl(Url.parse(relativeHomePage));
        add(new ExternalLink("su", IDP_SU + absoluteReturnURL));
    }
}
