package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.components.ListAdapterModel;
import se.su.dsv.scipro.profile.UserLabel;
import se.su.dsv.scipro.system.User;

import java.util.Set;

public class IdeaAuthorInfoPanel extends GenericPanel<Idea> {

    public IdeaAuthorInfoPanel(String id, IModel<Idea> model) {
        super(id, model);
        add(new ListView<IdeaParticipation>("authors", new ListAdapterModel<>(new PropertyModel<Set<IdeaParticipation>>(getModel(), "ideaParticipations"))) {
            @Override
            protected void populateItem(ListItem<IdeaParticipation> item) {
                item.add(new UserLabel("user", new PropertyModel<User>(item.getModel(), "user")));
            }
        });

        Label noAuthor = new Label("noAuthor", "Not available");
        noAuthor.setVisible(getModelObject().getIdeaParticipations().isEmpty());
        add(noAuthor);
    }

}
