package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.link.ResourceLink;
import org.apache.wicket.markup.html.panel.GenericPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.resource.CharSequenceResource;

public class IdeaDownloadPanel extends GenericPanel<Idea> {

    private final Idea idea;

    public IdeaDownloadPanel(String id, IModel<Idea> model) {
        super(id, model);
        idea = model.getObject();
        String ideaString = getIdeaString();
        CharSequenceResource resource = new CharSequenceResource("text/plain", ideaString, idea.getTitle() + ".txt");
        add(new ResourceLink<Idea>("download", resource));
    }

    private String getIdeaString() {
        StringBuilder sb = new StringBuilder("<<IDEA SPECIFICATION>>");
        String separator = System.getProperty("line.separator");
        sb.append(separator).append(separator);
        sb.append("Title: ").append(separator).append(idea.getTitle()).append(separator).append(separator);
        sb.append("Description: ").append(separator).append(idea.getDescription()).append(separator).append(separator);
        sb.append("Type: ").append(separator).append(idea.getType()).append(separator).append(separator);
        sb.append("Language: ").append(separator).append(idea.getLanguageNames()).append(separator).append(separator);
        sb.append("Prerequisites: ").append(separator).append(idea.getPrerequisites()).append(separator).append(separator);
        sb.append("ResearchArea: ").append(separator).append(idea.getResearchArea().getTitle()).append(separator).append(separator);
        sb.append("Keywords: ").append(separator).append(idea.getKeywordNames()).append(separator).append(separator);
        sb.append("Authors: ").append(separator).append(idea.getAuthorNames()).append(separator).append(separator);
        sb.append("Application period: ").append(separator).append(idea.getApplicationPeriod() == null ? "" : idea.getApplicationPeriod().getName()).append(separator).append(separator);
        sb.append("<<Watson's box>>").append(separator).append(separator);
        sb.append("What? ").append(separator).append(idea.getWatson().getWhat()).append(separator).append(separator);
        sb.append("Why? ").append(separator).append(idea.getWatson().getWhy()).append(separator).append(separator);
        sb.append("Theoretically how? ").append(separator).append(idea.getWatson().getTheoryHow()).append(separator).append(separator);
        sb.append("Practically how? ").append(separator).append(idea.getWatson().getPracticalHow());
        return sb.toString();
    }
}
