package se.su.dsv.scipro.match;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.ResourceModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorProjectIdea;
import se.su.dsv.scipro.data.DetachableServiceModel;

import javax.inject.Inject;
import java.util.List;

public class SupervisorAllStudentIdeasPage extends AbstractSupervisorProjectIdeaPage implements MenuHighlightSupervisorProjectIdea {

    @Inject
    private ApplicationPeriodService applicationPeriodService;

    public SupervisorAllStudentIdeasPage(PageParameters pp) {
        super(pp);

        List<ApplicationPeriod> currentPeriods = applicationPeriodService.getCurrentPeriods();
        if (currentPeriods.isEmpty()) {
            add(new Label("ideas", new ResourceModel("no.current.period")));
        }
        else {
            IModel<ApplicationPeriod> applicationPeriod = new DetachableServiceModel<>(applicationPeriodService, currentPeriods.get(0));
            add(new SupervisorAllStudentIdeasPanel("ideas", applicationPeriod));
        }
    }
}
