package se.su.dsv.scipro.match;


import com.google.inject.Inject;
import org.apache.wicket.markup.html.panel.EmptyPanel;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.util.string.StringValue;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.util.PageParameterKeys;

public class SupervisorIdeaStartPage extends AbstractSupervisorProjectIdeaPage {

    @Inject
    IdeaService ideaService;

    public SupervisorIdeaStartPage(PageParameters pp) {
        super(pp);
        FeedbackPanel feedbackPanel = new FeedbackPanel("feedbackPanel");
        add(feedbackPanel);
        feedbackPanel.setOutputMarkupId(true);

        if(getUser().hasRole(Roles.SUPERVISOR)) {
            Long ideaId = getIdFromParameter(pp, PageParameterKeys.MAP.get(Idea.class));

            if (ideaId != null) {
                IModel<Idea> idea = new DetachableServiceModel<>(ideaService, ideaId);
                add(new SupervisorMyIdeasPanel("myIdeasPanel", getUser(), idea));
            } else {
                add(new SupervisorMyIdeasPanel("myIdeasPanel", getUser()));
            }
        } else {
            add(new EmptyPanel("myIdeasPanel"));
        }
    }

    private Long getIdFromParameter(PageParameters pp, String parameter) {
        Long id = null;
        StringValue value = pp.get(parameter);
        if(!value.isNull()) {
            id = value.toLongObject();
        }
        return id;
    }
}
