package se.su.dsv.scipro.milestones.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightSupervisorMyProjects;
import se.su.dsv.scipro.milestones.panels.MileStoneOverviewPanel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorProjectDetailsPage;
import se.su.dsv.scipro.system.ProjectModule;

@Authorization(authorizedRoles = { Roles.SUPERVISOR})
@ProjectModuleComponent(ProjectModule.MILESTONES)
public class SupervisorMileStonePage extends AbstractSupervisorProjectDetailsPage implements MenuHighlightSupervisorMyProjects {

    static final String OVERVIEW_PANEL = "overviewPanel";

    public SupervisorMileStonePage(PageParameters pp) {
        super(pp);

        add(new MileStoneOverviewPanel(OVERVIEW_PANEL, projectModel) {
            @Override
            protected boolean isSupervisorView() {
                return true;
            }
        });
    }
}
