package se.su.dsv.scipro.notifications.pages;

import org.apache.wicket.markup.html.panel.FeedbackPanel;
import se.su.dsv.scipro.forum.mail.ForumMailReceiverSettingsPanel;
import se.su.dsv.scipro.notifications.panels.NotificationSettingsPanel;
import se.su.dsv.scipro.notifications.settings.panels.MemberDeliveryConfigurationPanel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.settings.pages.AbstractSettingsPage;

import static se.su.dsv.scipro.data.dataobjects.Member.Type.SUPERVISOR;

@Authorization(authorizedRoles = {Roles.SUPERVISOR})
public class SupervisorNotificationSettingsPage extends AbstractSettingsPage {
    static final String SETTINGS_PANEL = "settingsPanel";
    static final String FEEDBACK = "feedbackPanel";

    public SupervisorNotificationSettingsPage() {
        add(new FeedbackPanel(FEEDBACK).setOutputMarkupId(true));
        add(new ForumMailReceiverSettingsPanel("forumMail"));
        add(new NotificationSettingsPanel(SETTINGS_PANEL));
        add(new MemberDeliveryConfigurationPanel("deliveryConfiguration", SUPERVISOR));
    }
}
