package se.su.dsv.scipro.notifications.settings.panels;

import org.apache.wicket.markup.html.panel.Panel;
import se.su.dsv.scipro.notifications.dataobject.*;

public class DeliveryConfigurationPanel extends Panel {

    public DeliveryConfigurationPanel(String id) {
        super(id);
    }

    @Override
    protected void onInitialize() {
        super.onInitialize();

        add(createDeliveryPanel(PROJECT_EVENTS, Notification.Type.PROJECT, ProjectEvent.Event.values()));
        add(createDeliveryPanel(SEMINAR_EVENTS, Notification.Type.FINAL_SEMINAR, SeminarEvent.Event.values()));
        add(createDeliveryPanel(IDEA_EVENTS, Notification.Type.IDEA, IdeaEvent.Event.values()));
        add(createDeliveryPanel(PEER_EVENTS, Notification.Type.PEER, PeerEvent.Event.values()));
        add(createDeliveryPanel(MILESTONE_EVENTS, Notification.Type.MILESTONE, MileStoneEvent.Event.values()));
        add(createDeliveryPanel(FORUM_EVENTS, Notification.Type.FORUM, ProjectForumEvent.Event.values()));
        add(createDeliveryPanel(GROUP_EVENTS, Notification.Type.GROUP, GroupEvent.Event.values()));
    }

    protected TypeDeliveryConfigurationPanel createDeliveryPanel(final String id, final Notification.Type type, final Enum[] events) {
        return new TypeDeliveryConfigurationPanel(id, type, events);
    }

    static final String PEER_EVENTS = "peerEvents";
    static final String IDEA_EVENTS = "ideaEvents";
    static final String SEMINAR_EVENTS = "seminarEvents";
    static final String PROJECT_EVENTS = "projectEvents";
    static final String MILESTONE_EVENTS = "mileStoneEvents";
    static final String FORUM_EVENTS = "forumEvents";
    static final String GROUP_EVENTS = "groupEvents";
}
