package se.su.dsv.scipro.notifications.settings.panels;

import scala.Option;
import se.su.dsv.scipro.data.dataobjects.Member;
import se.su.dsv.scipro.notifications.dataobject.Notification;
import se.su.dsv.scipro.notifications.settings.entities.DeliveryMethod;
import se.su.dsv.scipro.notifications.settings.service.ReceiverConfigurationService;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.system.User;

import javax.inject.Inject;

public class MemberDeliveryConfigurationPanel extends DeliveryConfigurationPanel {

    @Inject
    ReceiverConfigurationService receiverConfiguration;

    private final Member.Type member;

    public MemberDeliveryConfigurationPanel(final String id, final Member.Type member) {
        super(id);

        this.member = member;
    }

    @Override
    protected TypeDeliveryConfigurationPanel createDeliveryPanel(final String id, final Notification.Type type, final Enum[] events) {
        return new TypeDeliveryConfigurationPanel(id, type, events) {
            @Override
            protected boolean isMethodEnabled(final DeliveryMethod method) {
                return method != DeliveryMethod.WEB;
            }

            @Override
            protected Option<User> getUser() {
                return Option.apply(SciProSession.get().getUser());
            }

            @Override
            protected boolean includeEvent(final Enum event) {
                return receiverConfiguration.isReceiving(type, event, member);
            }
        };
    }
}
