package se.su.dsv.scipro.peer;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.project.pages.AbstractProjectDetailsPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.ProjectModuleComponent;
import se.su.dsv.scipro.system.ProjectModule;

import static se.su.dsv.scipro.security.auth.roles.Roles.AUTHOR;

@Authorization(authorizedRoles = {AUTHOR})
@ProjectModuleComponent(ProjectModule.PEER)
public class AbstractPeerPortalPage extends AbstractProjectDetailsPage {
    public static final String PEER_REVIEW_GUIDE_PANEL = "peerReviewGuidePanel";
    public static final String MY_REQUEST_AND_REVIEWS_PANEL = "myRequestAndReviewsPanel";
    public static final String LATEST_REVIEW_PANEL = "latestReviewPanel";
    public static final String MOST_FREQUENT_REVIEWERS_PANEL = "mostFrequentReviewersPanel";

    public AbstractPeerPortalPage(PageParameters pp) {
        super(pp);
        add(new PeerReviewGuidePanel(PEER_REVIEW_GUIDE_PANEL));
        add(new MyPeerPanel(MY_REQUEST_AND_REVIEWS_PANEL, projectModel));
        add(new LatestReviewPanel(LATEST_REVIEW_PANEL));
    }
}
