package se.su.dsv.scipro.peer;

import org.apache.wicket.Page;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.admin.panels.PeerRequestStatsPanel;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.supervisor.pages.AbstractSupervisorAllProjectsPage;

import java.util.Collections;

import static se.su.dsv.scipro.security.auth.roles.Roles.SUPERVISOR;

@Authorization(authorizedRoles = {SUPERVISOR})
public class SupervisorPeersPage extends AbstractSupervisorAllProjectsPage {

    public SupervisorPeersPage(PageParameters pp) {
        super(pp);
        add(new PeerRequestStatsPanel("peerRequestStats"));
        add(new PeerReviewStatisticsPanel("peerReviewList", new PeerReviewStatisticsPanel.PageSupplier() {
            @Override
            public Page statusPage(IModel<PeerReview.ReviewStatus> model, PeerReviewService.Filter filter) {
                filter.setStatuses(Collections.singletonList(model.getObject()));
                return new SupervisorPeerReviewStatusStatisticsPage(filter);
            }

            @Override
            public Page chartPage(PeerReviewService.Filter filter) {
                return new SupervisorPeerReviewChartPage(filter);
            }
        }));
        add(new PeerRequestListPanel("peerRequestList"));
    }
}
