package se.su.dsv.scipro.project.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.basepages.MenuPage;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.project.panels.ProjectTabMenuPanel;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.springdata.services.UserProfileService;

import javax.inject.Inject;

public abstract class ProjectPage extends MenuPage {

    public static final String TAB_MENU = "tabMenu";

    @Inject
    private GeneralSystemSettingsService generalSystemSettingsService;

    @Inject
    private UserProfileService userProfileService;

    protected ProjectPage() {
        add(new ProjectTabMenuPanel(TAB_MENU, this.getClass()));
    }

    public ProjectPage(PageParameters pp) {
        super(pp);

        userProfileService.setSelectedRole(SciProSession.get().getUser(), Roles.AUTHOR);

        SciProSession.get().setSystemModules(generalSystemSettingsService.getGeneralSystemSettingsInstance().getSystemModules());
        add(new ProjectTabMenuPanel(TAB_MENU, this.getClass()));
    }


}
