package se.su.dsv.scipro.project.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.project.ProjectService;
import se.su.dsv.scipro.project.ProjectStatus;
import se.su.dsv.scipro.project.panels.ProjectsOverviewPanel;
import se.su.dsv.scipro.util.PageParameterKeys;

import javax.inject.Inject;
import java.util.Arrays;
import java.util.List;

public class ProjectStartPage extends ProjectPage {

    public static final String MAIN_MENU_LABEL = "Author";

    @Inject
    private ProjectService projectService;

    public ProjectStartPage(PageParameters pp) {
        super(pp);
        checkIfUserHasSingleProject();
        add(new ProjectsOverviewPanel("projectOverview"));
    }

    private void checkIfUserHasSingleProject() {
        ProjectService.Filter filter = new ProjectService.Filter();
        filter.setAuthorUser(getUser());
        filter.setStatuses(Arrays.asList(ProjectStatus.ACTIVE, ProjectStatus.COMPLETED));

        List<Project> projects = projectService.findAll(filter);
        if (projects.size() == 1) {
            PageParameters pp = new PageParameters();
            pp.add(PageParameterKeys.MAP.get(Project.class), projects.get(0).getId());
            setResponsePage(ProjectDetailsPage.class, pp);
        }
    }
}
