package se.su.dsv.scipro.projectpartner;

import org.apache.wicket.markup.repeater.data.IDataProvider;
import org.apache.wicket.model.IModel;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import se.su.dsv.scipro.data.DetachableServiceModel;
import se.su.dsv.scipro.system.ProjectType;

import java.util.Iterator;

public class ProjectPartnerDataProvider implements IDataProvider<ProjectPartner> {

    private ProjectPartnerService projectPartnerService;
    private final IModel<ProjectType> model;
    private int days;

    @Override
    public void detach() {
        model.detach();
    }

    public ProjectPartnerDataProvider(final ProjectPartnerService projectPartnerService, int days, final IModel<ProjectType> model) {
        this.projectPartnerService = projectPartnerService;
        this.days = days;
        this.model = model;
    }

    @Override
    public Iterator<? extends ProjectPartner> iterator(long first, long count) {
        return projectPartnerService.getProjectPartnerInSpan(days, model.getObject(), new PageRequest(first, count, new Sort(Sort.Direction.DESC, "dateCreated"))).iterator();
    }

    @Override
    public long size() {
        return projectPartnerService.countProjectPartnerInSpan(days, model.getObject());
    }

    @Override
    public IModel<ProjectPartner> model(ProjectPartner object) {
        return new DetachableServiceModel<>(projectPartnerService, object);
    }

}
