package se.su.dsv.scipro.repository;


import org.apache.wicket.protocol.http.WebApplication;
import se.su.dsv.scipro.system.Lifecycle;

import javax.inject.Inject;
import java.util.Collections;
import java.util.Set;

public abstract class LifecycleManagedWebApplication extends WebApplication {

    @Inject
    private Set<Lifecycle> lifecycles = Collections.emptySet();

    @Override
    protected void init() {
        super.init();
        for (Lifecycle lifecycle : lifecycles) {
            lifecycle.start();
        }
    }

    @Override
    protected void onDestroy() {
        for (Lifecycle lifecycle : lifecycles) {
            lifecycle.stop();
        }
        super.onDestroy();
    }
}
