package se.su.dsv.scipro.repository.components;

import org.apache.wicket.model.IModel;
import org.apache.wicket.request.resource.AbstractResource;
import org.apache.wicket.util.io.IOUtils;
import se.su.dsv.scipro.file.FileDescription;

import java.io.IOException;
import java.io.InputStream;

class FileResource extends AbstractResource {
    protected final IModel<? extends FileDescription> model;

    public FileResource(IModel<? extends FileDescription> model) {
        this.model = model;
    }

    @Override
    protected ResourceResponse newResourceResponse(Attributes attributes) {
        final ResourceResponse resourceResponse = new ResourceResponse();
        final FileDescription fileDescription = model.getObject();

        resourceResponse.setContentType(fileDescription.getMimeType());
        resourceResponse.setContentLength(fileDescription.getSize());
        resourceResponse.setFileName(fileDescription.getName());

        if (resourceResponse.dataNeedsToBeWritten(attributes)) {
            resourceResponse.setWriteCallback(new WriteCallback() {
                @Override
                public void writeData(Attributes attributes) throws IOException {
                    try (InputStream data = fileDescription.getData()) {
                        IOUtils.copy(data, attributes.getResponse().getOutputStream());
                    }
                }
            });
        }

        configureResponse(resourceResponse);

        return resourceResponse;
    }

    protected void configureResponse(ResourceResponse resourceResponse) {
    }
}
