package se.su.dsv.scipro.statistics;

import org.apache.wicket.markup.html.panel.FeedbackPanel;
import se.su.dsv.scipro.admin.pages.AbstractAdminPage;
import se.su.dsv.scipro.components.AbstractMenuPanel;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAdminAuthorStatistics;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAdminMileStoneStatistics;
import se.su.dsv.scipro.components.menuhighlighting.MenuHighlightAdminPeer;
import se.su.dsv.scipro.match.AdminIdeaStatisticsPage;
import se.su.dsv.scipro.match.AdminIdeaStatusStatisticsPage;
import se.su.dsv.scipro.peer.AdminPeersPage;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;

import java.util.ArrayList;
import java.util.List;

@Authorization(authorizedRoles = { Roles.ADMIN })
public abstract class AbstractAdminStatisticsPage extends AbstractAdminPage {

    protected AbstractAdminStatisticsPage() {
        add(new FeedbackPanel("feedbackPanel").setOutputMarkupId(true));
		add(new AbstractMenuPanel("menuPanel", AbstractAdminStatisticsPage.class, this.getClass()){
            @Override
			protected List<MenuItem> getItemList() {
				final List<MenuItem> items = new ArrayList<>();
                items.add(new MenuItem("Ideas", AdminIdeaStatisticsPage.class));
				items.add(new MenuItem("Idea statuses", AdminIdeaStatusStatisticsPage.class));
                items.add(new MenuItem("Unmet targets", AdminUnmetTargetsStatisticsPage.class));
                items.add(new MenuItem("Peers", AdminPeersPage.class, MenuHighlightAdminPeer.class));
                items.add(new MenuItem("Supervisors commitments", SupervisorStatisticsPage.class));
                items.add(new MenuItem("Projects connected to external org", ProjectExternalStatisticsPage.class));
                items.add(new MenuItem("Units", AdminUnitStatisticsPage.class));
                items.add(new MenuItem("Authors", AdminAuthorsStatisticsPage.class, MenuHighlightAdminAuthorStatistics.class));
                items.add(new MenuItem("Milestones", AdminMilestoneStatisticsPage.class, MenuHighlightAdminMileStoneStatistics.class));
                items.add(new MenuItem("Milestone progress", AdminMilestoneStatisticsProgressPage.class));
                items.add(new MenuItem("Milestone median", AdminMedianMilestonePage.class));
				items.add(new MenuItem("Unfinished final seminars", AdminUnfinishedFinalSeminarsPage.class));
                items.add(new MenuItem("Reviewer deadlines", AdminReviewerDeadlinesPage.class));
                items.add(new MenuItem("People", AdminPeopleStatisticsPage.class));
                items.add(new MenuItem("Final seminars", AdminFinalSeminarStatisticsPage.class));
                items.add(new MenuItem("Final grades", AdminGradeStatisticsPage.class));
                return items;
			}
			@Override
			protected MenuType getMenuType() {
				return MenuType.HORIZONTAL;
			}
		});
	}
}