package se.su.dsv.scipro.statistics;

import org.apache.wicket.Page;
import org.apache.wicket.model.IModel;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.milestones.service.MileStoneService;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;

@Authorization(authorizedRoles = {Roles.ADMIN})
public class AdminMilestoneStatisticsPage extends AbstractAdminStatisticsPage {

    public AdminMilestoneStatisticsPage() {
        add(new MilestoneStatisticsPanel("statistics", new MilestoneStatisticsPanel.PageSupplier() {
            @Override
            public Page individualPage(IModel<MilestoneActivityTemplate> model, MileStoneService.Filter filter) {
                return new AdminIndividualMilestoneDetailsPage(model, filter);
            }
            @Override
            public Page projectPage(IModel<MilestoneActivityTemplate> model, MileStoneService.Filter filter) {
                return new AdminProjectMilestoneDetailsPage(model, filter);
            }

            @Override
            public Page chartPage(MileStoneService.Filter filter) {
                return new AdminMilestoneChartPage(filter);
            }
        }));
    }
}
