package se.su.dsv.scipro.statistics;

import com.googlecode.wickedcharts.highcharts.options.*;

import java.util.List;

public class BarColumnOptions extends Options {

    public BarColumnOptions(String yTitle, List<String> categories) {
        setChartOptions(new ChartOptions().setType(SeriesType.COLUMN));
        setTitle(new Title(""));
        setyAxis(new Axis().setTitle(new Title(yTitle)).setAllowDecimals(false));
        setxAxis(new Axis().setCategories(categories));
        setLegend(new Legend().setLayout(LegendLayout.VERTICAL)
                .setAlign(HorizontalAlignment.RIGHT).setVerticalAlign(VerticalAlignment.TOP)
                .setX(-10).setY(100).setBorderWidth(0));
        setPlotOptions(new PlotOptionsChoice()
                .setColumn(new PlotOptions().setStacking(Stacking.NORMAL)));
        setExporting(new ExportingOptions().setEnabled(false));
        setCredits(new CreditOptions().setEnabled(false));
    }
}
