package se.su.dsv.scipro.statistics;

import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.ResourceModel;
import se.su.dsv.scipro.components.DateColumn;
import se.su.dsv.scipro.milestones.dataobjects.Milestone;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.milestones.service.MileStoneService;

import java.util.ArrayList;
import java.util.List;

public class IndividualMilestoneDetailsPanel extends AbstractMilestoneDetailsPanel {

    public IndividualMilestoneDetailsPanel(String id, IModel<MilestoneActivityTemplate> model, MileStoneService.Filter filter) {
        super(id, model, filter);
    }

    @Override
    protected List<IColumn<Milestone, String>> createColumns() {
        List<IColumn<Milestone, String>> columns = new ArrayList<>();
        columns.add(new DateColumn<Milestone>(new ResourceModel("project.creation.date"), "project.dateCreated", "project.dateCreated"));
        columns.add(new PropertyColumn<Milestone, String>(new ResourceModel("project.title"), "project.title", "project.title"));
        columns.add(new PropertyColumn<Milestone, String>(new ResourceModel("project.type"), "project.projectType.name", "project.projectTypeName"));
        columns.add(new PropertyColumn<Milestone, String>(new ResourceModel("author"), "user.fullName"));
        columns.add(new PropertyColumn<Milestone, String>(new ResourceModel("project.status"), "project.projectStatus"));
        columns.add(new PropertyColumn<Milestone, String>(new ResourceModel("project.supervisor"), "project.headSupervisor.firstName", "project.headSupervisor.firstName"));
        columns.add(new DateColumn<Milestone>(new ResourceModel("milestone.completion.date"), "lastModified", "lastModified"));
        return columns;
    }
}
