package se.su.dsv.scipro.supervisor.pages;

import org.apache.wicket.request.mapper.parameter.PageParameters;
import se.su.dsv.scipro.basepages.MenuPage;
import se.su.dsv.scipro.generalsystemsettings.GeneralSystemSettingsService;
import se.su.dsv.scipro.security.auth.Authorization;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.session.SciProSession;
import se.su.dsv.scipro.springdata.services.UserProfileService;
import se.su.dsv.scipro.supervisor.panels.SupervisorTabMenuPanel;

import javax.inject.Inject;

@Authorization(authorizedRoles = {Roles.SUPERVISOR})
public abstract class AbstractSupervisorPage extends MenuPage {

    @Inject
    private UserProfileService userProfileService;

    @Inject
    private GeneralSystemSettingsService generalSystemSettingsService;

    protected AbstractSupervisorPage() {
        add(new SupervisorTabMenuPanel("tabMenu", this.getClass()));
    }

    public AbstractSupervisorPage(PageParameters pp) {
        super(pp);
        userProfileService.setSelectedRole(SciProSession.get().getUser(), Roles.SUPERVISOR);
        SciProSession.get().setSystemModules(generalSystemSettingsService.getGeneralSystemSettingsInstance().getSystemModules());
        add(new SupervisorTabMenuPanel("tabMenu", this.getClass()));
    }
}
