package se.su.dsv.scipro.util;

import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.FormComponent;
import org.apache.wicket.markup.html.form.validation.AbstractFormValidator;
import org.apache.wicket.util.lang.Objects;
import org.apache.wicket.validation.ValidationError;

public class OrValidator extends AbstractFormValidator {

    private final FormComponent<?>[] components;

    public OrValidator(FormComponent<?> formComponent1, FormComponent<?> formComponent2) {
        if (formComponent1 == null)
        {
            throw new IllegalArgumentException("argument formComponent1 cannot be null");
        }
        if (formComponent2 == null)
        {
            throw new IllegalArgumentException("argument formComponent2 cannot be null");
        }
        components = new FormComponent[] { formComponent1, formComponent2 };
    }

    @Override
    public FormComponent<?>[] getDependentFormComponents() {
        return components;
    }

    @Override
    public void validate(Form<?> form) {

        final FormComponent<?> formComponent1 = components[0];
        final FormComponent<?> formComponent2 = components[1];
        if((formComponent1.getInput()==null||Objects.stringValue(formComponent1.getInput(), true).equals(""))
                && (formComponent2.getInput()==null||Objects.stringValue(formComponent2.getInput(), true).equals(""))){
            ValidationError ve = new ValidationError();
            ve.setVariables(OrValidator.this.variablesMap());
            ve.addKey(resourceKey());
            components[0].error(ve);
        }

    }
}
