package se.su.dsv.scipro.util;

import com.google.common.collect.ImmutableMap;
import se.su.dsv.scipro.activityplan.Activity;
import se.su.dsv.scipro.activityplan.ActivityPlan;
import se.su.dsv.scipro.activityplan.ActivityPlanTemplate;
import se.su.dsv.scipro.checklist.Checklist;
import se.su.dsv.scipro.checklist.ChecklistTemplate;
import se.su.dsv.scipro.finalseminar.FinalSeminar;
import se.su.dsv.scipro.finalseminar.FinalSeminarOpposition;
import se.su.dsv.scipro.forum.dataobjects.ForumPost;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.group.Group;
import se.su.dsv.scipro.match.ApplicationPeriod;
import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.peer.PeerRequest;
import se.su.dsv.scipro.peer.PeerReview;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.User;

import java.util.Map;

public final class PageParameterKeys {

    /**
     * Suppress default constructor for noninstantiability. For details about this, see
     * http://stackoverflow.com/questions/1844355/java-static-class
     */
    private PageParameterKeys() {
        throw new AssertionError();
    }

    public static final Map<Class, String> MAP = ImmutableMap.<Class, String>builder()
            .put(ActivityPlanTemplate.class, "stid")
            .put(Activity.class, "acid")
            .put(ActivityPlan.class, "actp")
            .put(ApplicationPeriod.class, "apid")
            .put(Checklist.class, "clid")
            .put(ChecklistTemplate.class, "cltid")
            .put(FinalSeminar.class, "fsid")
            .put(FinalSeminarOpposition.class, "oid")
            .put(ForumPost.class, "fpid")
            .put(Idea.class, "ideaid")
            .put(PeerRequest.class, "requestid")
            .put(PeerReview.class, "reviewid")
            .put(Project.class, "pid")
            .put(User.class, "uid")
            .put(Group.class, "gid")
            .put(ForumThread.class, "tid")
            .build();
}