package se.su.dsv.scipro.components

import org.apache.wicket.model.LoadableDetachableModel

trait Persister[A] {
  def load(id: Long): Option[A]
  def id(a: A): Option[java.lang.Long]
}

final class DetachableModel[A >: Null : Persister] extends LoadableDetachableModel[A] {
  private val $persister = implicitly[Persister[A]]
  private var id: Option[Long] = None
  private var obj: Option[A] = None

  def this(a: A) = {
    this
    obj = Some(a)
  }

  def this(id: Long) = {
    this
    this.id = Some(id)
  }

  override def load() = obj.orElse(id.flatMap($persister.load)).orNull

  override def onDetach(): Unit = {
    if (isAttached) {
      id = $persister.id(getObject).map(_.toLong)
      if (id.isDefined) obj = None
      else obj = Some(getObject)
    }
  }
}
