package se.su.dsv.scipro.components.datatables

import java.util.{List => JList}

import org.apache.wicket.Component
import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator
import org.apache.wicket.extensions.markup.html.repeater.data.table.export.AbstractExportableColumn
import org.apache.wicket.markup.repeater.Item
import org.apache.wicket.model.{AbstractReadOnlyModel, IModel}
import se.su.dsv.scipro.components.DisplayMultiplesPanel
import se.su.dsv.scipro.profile.UserLinkPanel
import se.su.dsv.scipro.system.User

import scala.collection.JavaConverters.iterableAsScalaIterableConverter

abstract class MultipleUsersColumn[T, S](displayModel: IModel[String]) extends AbstractExportableColumn[T, S, String](displayModel) {

  protected def getUsers(rowModel: IModel[T]): IModel[_ <: JList[_ <: User]]

  override def populateItem(cellItem: Item[ICellPopulator[T]], componentId: String, rowModel: IModel[T]): Unit = {
    cellItem.add(new DisplayMultiplesPanel[User](componentId, getUsers(rowModel)) {
      def getComponent(componentId: String, model: IModel[User]): Component = {
        new UserLinkPanel(componentId, model)
      }
    })
  }

  def getDataModel(rowModel: IModel[T]): IModel[String] = {
    new AbstractReadOnlyModel[String] {
      def getObject: String = {
        val users = getUsers(rowModel).getObject
        users.asScala.map(_.getFullName) mkString ", "
      }
    }
  }
}