package se.su.dsv.scipro.admin.panels;

import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.FooterAddress;

import java.util.Arrays;
import java.util.Collections;

import static org.mockito.Matchers.anyLong;
import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class AdminEditFooterAddressPanelTest extends SciProTest {

    private AdminEditFooterAddressPanel panel;

    @Before
    @Test
    public void setUp() throws Exception {
        FooterAddress footerAddress = newFooterAddress();
        when(footerAddressRepo.findAll()).thenReturn(Collections.singletonList(footerAddress));
        panel = tester.startComponentInPage(new AdminEditFooterAddressPanel("id"));
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel, "form"));
        formTester.setValue("title", "some title");
        formTester.setValue("address", "some address");
        when(footerAddressRepo.findOne(anyLong())).thenReturn(newFooterAddress());
        formTester.submit();
        verify(footerAddressRepo).save(isA(FooterAddress.class));
        tester.assertInfoMessages(panel.getString("saved"));
    }


    private FooterAddress newFooterAddress() {
        FooterAddress footerAddress = new FooterAddress();
        footerAddress.setTitle("DSV");
        footerAddress.setTitle("KISTA, SWEDEN");
        return footerAddress;
    }
}
