package se.su.dsv.scipro.components;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.project.Project;

@RunWith(MockitoJUnitRunner.class)
public class AjaxLinkPanelTest extends SciProTest {

    Project project;
    AjaxLinkPanel<Project> panel;

    @Before
    public void setUp() throws Exception {
        project = new Project();
        project.setTitle("blabla");
        startPanel();
    }

    @Test
    public void testRenders() throws Exception {
        Assert.assertNotNull("Panel does not render", panel);
    }

    @Test
    public void testLinkVisible() throws Exception {
        tester.assertComponent(path(panel.getId(), AjaxLinkPanel.LINK), AjaxLink.class);
        tester.assertVisible(path(panel.getId(), AjaxLinkPanel.LINK));
    }

    @Test
    public void testLabelVisible() throws Exception {
        tester.assertComponent(path(panel.getId(), AjaxLinkPanel.LINK, AjaxLinkPanel.LABEL), Label.class);
        tester.assertVisible(path(panel.getId(), AjaxLinkPanel.LINK, AjaxLinkPanel.LABEL));
    }

    private void startPanel() {
        panel = tester.startComponentInPage(new AjaxLinkPanel<Project>("panel", Model.of(project), new PropertyModel(project, "title")) {
            @Override
            public void onClick(AjaxRequestTarget target, IModel<Project> model) {
                //do nothing
            }
        });
    }
}