package se.su.dsv.scipro.finalseminar;

import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.system.ProjectModule;

import static org.hamcrest.core.StringContains.containsString;
import static org.junit.Assert.assertThat;
import static org.mockito.Mockito.when;

public class SupervisorFinalSeminarListingPageTest extends SciProTest {

    @Test
    public void renders() throws Exception {
        tester.startPage(SupervisorFinalSeminarListingPage.class);
        tester.assertRenderedPage(SupervisorFinalSeminarListingPage.class);
    }

    @Test
    public void final_versions_is_visible() throws Exception {
        when(projectTypeService.projectTypeWithModuleExists(ProjectModule.GRADING)).thenReturn(true);
        assertVisible("Final theses");
    }

    @Test
    public void activity_plan_is_visible_if_module_is_on() throws Exception {
        when(projectTypeService.projectTypeWithModuleExists(ProjectModule.ACTIVITY_PLAN)).thenReturn(true);
        assertVisible("Activity plan templates");
    }

    @Test
    public void peer_is_visible_if_module_is_on() throws Exception {
        when(projectTypeService.projectTypeWithModuleExists(ProjectModule.PEER)).thenReturn(true);
        assertVisible("Peers");
    }

    @Test
    public void milestone_statistics_is_visible_if_module_is_on() throws Exception {
        when(projectTypeService.projectTypeWithModuleExists(ProjectModule.MILESTONES)).thenReturn(true);
        assertVisible("Milestone statistics");
    }

    @Test
    public void final_seminar_is_visible_if_module_is_on() throws Exception {
        when(projectTypeService.projectTypeWithModuleExists(ProjectModule.FINAL_SEMINAR)).thenReturn(true);
        assertVisible("Final seminars");
    }

    private String renderedPage() {
        tester.startPage(SupervisorFinalSeminarListingPage.class);
        return tester.getLastResponseAsString();
    }

    private void assertVisible(String menuChoice) {
        assertThat(renderedPage(), containsString(menuChoice));
    }

}
