package se.su.dsv.scipro.forum.panels.threaded;

import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.pages.InternalErrorPage;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.forum.Discussable;
import se.su.dsv.scipro.forum.dataobjects.ForumPost;
import se.su.dsv.scipro.forum.dataobjects.ForumThread;
import se.su.dsv.scipro.system.User;

import java.util.Arrays;
import java.util.List;

@RunWith(MockitoJUnitRunner.class)
public class ThreadsOverviewPanelTest extends SciProTest {

    private List<ForumThread> threads;

    @Before
    public void setUp() throws Exception {
        ForumThread forumThread = createThread();
        threads = Arrays.asList(forumThread);
    }

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    private void startPanel() {
        IModel<List<ForumThread>> listIModel = Model.of(Model.ofList(threads)); // Yay Java wildcards
        tester.startComponentInPage(new ThreadsOverviewPanel<>("id", listIModel, new Discussable<ForumThread>() {
            @Override
            public IModel<ForumThread> discussion(final IModel<ForumThread> a) {
                return a;
            }
        }, new ThreadsOverviewPanel.ThreadLinkSupplier<ForumThread>() {
            @Override
            public BookmarkablePageLink<Void> newThreadLink(final String id, final IModel<ForumThread> thread) {
                return new BookmarkablePageLink<>(id, InternalErrorPage.class);
            }
        }));
    }

    private ForumThread createThread() {
        User bob = User.builder().firstName("Bob").lastName("the Builder").emailAddress("bob@building.com").build();
        ForumPost post = new ForumPost();
        post.setPostedBy(bob);
        ForumThread groupForumThread = new ForumThread();
        groupForumThread.addPost(post);
        return groupForumThread;
    }
}