package se.su.dsv.scipro.match;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.model.Model;
import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class EditKeywordPanelTest extends SciProTest {

    EditKeywordPanel panel;
    Keyword keyword;

    @Before
    public void setUp() throws Exception {
        keyword = new Keyword();
        keyword.setId(1L);
        when(keywordService.save(isA(Keyword.class))).thenReturn(keyword);
        startPanel();
    }

    @Test
    public void must_enter_keyword() throws Exception {
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertErrorMessages("'keyword' is required.");
    }

    @Test
    public void saves() throws Exception {
        FormTester formTester = tester.newFormTester(path(panel.getId(), "form"));
        formTester.setValue(path("wmc", "keyword"), "nice keyword");
        tester.executeAjaxEvent(path(panel.getId(), "form", "save"), "onclick");
        tester.assertInfoMessages("Saved");
        verify(keywordService).save(isA(Keyword.class));
    }

    private void startPanel() throws Exception {
        panel = tester.startComponentInPage(new EditKeywordPanel("id", Model.of(keyword)) {
            @Override
            public void onSave(AjaxRequestTarget target) {

            }
        });
    }
}