package se.su.dsv.scipro.match;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Matchers;
import org.mockito.Mockito;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.util.PageParameterKeys;

public class ProjectNewAllSupervisorIdeasPageTest extends PageTest {

    @Before
    public void setUp() throws Exception {
        Mockito.when(applicationPeriodService.findOne(Matchers.anyLong())).thenReturn(new ApplicationPeriod());
    }

    @Test
    public void go_to_page_with_invalid_page_parameters() throws Exception {
        tester.startPage(getPage());

        tester.assertRenderedPage(ProjectIdeaStartPage.class);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return ProjectNewAllSupervisorIdeasPage.class;
    }

    @Override
    protected PageParameters getPageParameters() {
        PageParameters pageParameters = new PageParameters();
        pageParameters.set(PageParameterKeys.MAP.get(ApplicationPeriod.class), "1");
        return pageParameters;
    }
}
