package se.su.dsv.scipro.match;

import org.apache.wicket.Page;
import org.junit.Test;
import org.mockito.Mockito;
import se.su.dsv.scipro.PageTest;

import java.util.Collections;
import java.util.Date;

public class SupervisorAllStudentIdeasPageTest extends PageTest {

    @Test
    public void shows_label_if_no_current_period() throws Exception {
        Mockito.when(applicationPeriodService.getCurrentPeriods()).thenReturn(Collections.<ApplicationPeriod>emptyList());

        startPage();

        tester.assertLabel("ideas", tester.getLastRenderedPage().getString("no.current.period"));
    }

    @Test
    public void displays_panel_with_current_period_if_there_is_one() throws Exception {
        ApplicationPeriod applicationPeriod = createCurrentPeriod();
        Mockito.when(applicationPeriodService.getCurrentPeriods()).thenReturn(Collections.singletonList(applicationPeriod));

        startPage();

        tester.assertComponent("ideas", SupervisorAllStudentIdeasPanel.class);
        tester.assertModelValue("ideas", applicationPeriod);
    }

    private ApplicationPeriod createCurrentPeriod() {
        ApplicationPeriod applicationPeriod = new ApplicationPeriod();
        applicationPeriod.setStartDate(new Date(0));
        applicationPeriod.setEndDate(new Date(System.currentTimeMillis() + 239874293784L));
        return applicationPeriod;
    }

    @Override
    protected Class<? extends Page> getPage() {
        return SupervisorAllStudentIdeasPage.class;
    }
}
