package se.su.dsv.scipro.nonworkdays;

import org.apache.wicket.Page;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.components.ExportableDataPanel;
import se.su.dsv.scipro.components.ModalWindowPlus;
import se.su.dsv.scipro.security.auth.roles.Roles;

@RunWith(MockitoJUnitRunner.class)
public class NonWorkDaysPageTest extends PageTest {

    NonWorkDaysPage page;

    @Before
    public void setUp() throws Exception {
        setLoggedIn(true);
        setRoles(Roles.SYSADMIN);
        page = tester.startPage(NonWorkDaysPage.class);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return NonWorkDaysPage.class;
    }

    @Test
    public void testContainsSettingsPanel() throws Exception {
        tester.assertComponent(NonWorkDaysPage.DIALOG, ModalWindowPlus.class);
        tester.assertComponent(NonWorkDaysPage.ADD, AjaxLink.class);
        tester.assertComponent(NonWorkDaysPage.FEEDBACK, FeedbackPanel.class);
        tester.assertComponent(NonWorkDaysPage.DATA_PANEL, ExportableDataPanel.class);
    }
}