package se.su.dsv.scipro.notifications.pages;

import org.apache.wicket.Page;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.notifications.panels.NotificationSettingsPanel;
import se.su.dsv.scipro.notifications.settings.service.DeliveryConfigurationService;
import se.su.dsv.scipro.notifications.settings.service.ReceiverConfigurationService;
import se.su.dsv.scipro.security.auth.roles.Roles;
import se.su.dsv.scipro.settings.dataobjects.UserProfile;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.UserBuilder;

import static org.mockito.Mockito.when;


public class SupervisorNotificationSettingsPageTest extends PageTest {

    @Mock ReceiverConfigurationService receiverConfiguration;
    @Mock DeliveryConfigurationService deliveryConfiguration;

	SupervisorNotificationSettingsPage page;
	
    @Before
    public void setUp() {
        setRoles(Roles.SUPERVISOR);
        setLoggedIn(true);
        User user = new UserBuilder().create();
        setLoggedInAs(user);
        when(userProfileService.findByUser(user)).thenReturn(new UserProfile());
        page =  tester.startPage(SupervisorNotificationSettingsPage.class);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return SupervisorNotificationSettingsPage.class;
    }

    @Test
    public void testPageContainsSettingsPanel() throws Exception {
    	tester.assertComponent(SupervisorNotificationSettingsPage.SETTINGS_PANEL, NotificationSettingsPanel.class);
    }
}
