package se.su.dsv.scipro.peer;

import org.apache.wicket.model.Model;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.checklist.ChecklistTemplate;
import se.su.dsv.scipro.project.Project;
import se.su.dsv.scipro.system.DegreeLevel;
import se.su.dsv.scipro.system.ProjectType;

public class RequestDetailsPanelTest extends SciProTest {

    public static final ProjectType SOME_PROJECT_TYPE = new ProjectType(DegreeLevel.FIRST_CYCLE, "bachelor", "bachelor");
    private RequestDetailsPanel panel;

    @Test
    public void renders() throws Exception {
        startPanel();
    }

    @Test
    public void open_checklist_template_dialog() throws Exception {
        startPanel();

        tester.clickLink(path(panel, RequestDetailsPanel.TEMPLATE_LINK));
        tester.assertComponentOnAjaxResponse(path(panel, RequestDetailsPanel.DIALOG));
    }

    private void startPanel() {
        PeerRequest peerRequest = new PeerRequest();
        peerRequest.setProject(Project.builder().title("title").projectType(SOME_PROJECT_TYPE).build());
        ChecklistTemplate checklistTemplate = new ChecklistTemplate();
        checklistTemplate.addQuestion("question");
        peerRequest.setChecklistTemplate(checklistTemplate);
        panel = tester.startComponentInPage(new RequestDetailsPanel("id", Model.of(peerRequest)));
    }
}
