package se.su.dsv.scipro.profile;

import org.apache.wicket.model.Model;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.runners.MockitoJUnitRunner;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.match.Idea;
import se.su.dsv.scipro.match.IdeaParticipation;
import se.su.dsv.scipro.system.Program;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.test.UserBuilder;

import static org.junit.Assert.assertNotNull;

@RunWith(MockitoJUnitRunner.class)
public class StudentProfileProgramPanelTest extends SciProTest {
    StudentProfileProgramPanel panel;
    IdeaParticipation nip;
    @Before
    public void setUp() throws Exception {
        final User user = new UserBuilder().create();

        Program program = new Program();
        program.setName("Kandidatexamen i Data och Systemvetenskap");

        nip = new IdeaParticipation(user, new Idea());
        nip.setProgram(program);

        panel = tester.startComponentInPage(new StudentProfileProgramPanel("id", Model.of(nip), false));
    }

    @Test
    public void testRenders() throws Exception {
        assertNotNull("Panel does not render", panel);
    }

    @Override
    protected String path(Object... parts) {
        return super.path(panel.getId(), super.path(parts));
    }
}
