package se.su.dsv.scipro.statistics;

import org.apache.wicket.util.tester.FormTester;
import org.junit.Before;
import org.junit.Test;
import se.su.dsv.scipro.SciProTest;
import se.su.dsv.scipro.milestones.dataobjects.MilestoneActivityTemplate;
import se.su.dsv.scipro.milestones.dataobjects.MilestonePhaseTemplate;
import se.su.dsv.scipro.test.DomainObjects;

import java.util.Arrays;

import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

public class MilestoneStatisticsProgressPanelTest extends SciProTest {
    private MilestoneActivityTemplate completed;
    private MilestoneActivityTemplate notCompleted;

    @Before
    public void setUp() throws Exception {
        MilestonePhaseTemplate phase = new MilestonePhaseTemplate();
        completed = new MilestoneActivityTemplate(MilestoneActivityTemplate.Type.PROJECT);
        completed.setMilestonePhaseTemplate(phase);
        DomainObjects.injectId(completed, 1L);
        notCompleted = new MilestoneActivityTemplate(MilestoneActivityTemplate.Type.PROJECT);
        notCompleted.setMilestonePhaseTemplate(phase);
        DomainObjects.injectId(notCompleted, 2L);

        when(milestoneActivityTemplateService.findAll()).thenReturn(Arrays.asList(completed, notCompleted));

        tester.startComponentInPage(MilestoneStatisticsProgressPanel.class);
    }

    @Test
    public void select_milestones() throws Exception {
        FormTester selection = tester.newFormTester("selection");
        selection.setValue("completed", "1");
        selection.setValue("notCompleted", "2");
        selection.submit();

        verify(milestoneStatisticsService).countProgressedProjects(completed, notCompleted);
    }
}