package se.su.dsv.scipro.supervisor.pages;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.junit.Before;
import se.su.dsv.scipro.PageTest;
import se.su.dsv.scipro.group.Group;
import se.su.dsv.scipro.system.User;
import se.su.dsv.scipro.util.PageParameterKeys;

import static org.mockito.Matchers.isA;
import static org.mockito.Mockito.when;

public class SupervisorGroupPageTest extends PageTest {

    Group group;
    User user;

    @Before
    public void setUp() throws Exception {
        group = new Group();
        group.setId(1L);
        user = User.builder().firstName("John").lastName("Smith").emailAddress("john@example.com").build();
        group.setUser(user);
        when(groupService.findOne(isA(Long.class))).thenReturn(group);
        when(groupFacade.isSupervisorOrFollower(isA(Group.class), isA(User.class))).thenReturn(true);
    }

    @Override
    protected Class<? extends Page> getPage() {
        return SupervisorGroupPage.class;
    }

    @Override
    protected PageParameters getPageParameters() {
        PageParameters pageParameters = new PageParameters();
        pageParameters.add(PageParameterKeys.MAP.get(Group.class), 1);
        return pageParameters;
    }

}